/* Generated by Together */

package bemessung.betontraeger;

import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.awt.event.*;

/**
 * Biegebemessung und Ermittlung des Bewehrungsgrad fr zugbewehrte Querschnitte. Das Bean dient als API fr die dahinter verborgenen Rutinen und wird somit nur mit einfachen Datentypen versorgt.
 * @author Johannes Hoehne*/
final public class StuetzenBean implements Serializable, ActionListener, Betonteile {
	/**
     * maximales Moment in [MNm]
     */
    private double m;

	/**
     * maximale Normalkraft in [MN]
     */
    private double n;
	/**
     * maximale Querkraft in [MN]
     */
    private double q;

	/**
     * Lnge des Bauteils
     */
    private double l;

	/**
     * statische Hhe des Querschnitts in [m]
     */
    private double h;
	/**
     * statische Betondeckungs in [m]
     */
    private double d1;

	/**
     * Breite des Querschnitts in [m]
     */
    private double b;
	/**
     * Bezeichnung des Betons
     */
    private String beton;
    private PropertyChangeSupport propertyChangeSupport = new java.beans.PropertyChangeSupport(this);
    private double gammaC;
    private double gammaS;

	/**
     * Streckgrenze des Baustahls in [MN/m^2]
     */
    private double fyk;

    /**
         * Ntige Zugbewehrung in [cm^2]
         */
    private double az;

    /**
             * Ntige Schubbwehrung in [cm^2/m]
             */
    private double aq;

	/**
     * Knickuntersuchung durchfhren oder nicht
     */
    private boolean knick;

    /**
     * Parameterloser Konstruktor des Beans 
     */
    public void BalkenBean() {
    }

    private void writeObject(ObjectOutputStream oos) throws IOException {
        // Write the non-static and non-transient fields of the current class to this stream
        oos.defaultWriteObject();
    }

    private void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException {
        // Read the non-static and non-transient fields of the current class from this stream
        ois.defaultReadObject();
    }

    /**
     * Liefert das Moment der Bemessung [MNm]
     * @return Das maximale Moment im Querschnitt in [MNm]
     */
    public double getM(){ return m; }

    /**
     * Setzt das Moment fr die Bemessung fest [MNm]
     * @param m Das maximale Moment im Querschnitt in [MNm]
     */
    public void setM(double m){ this.m = m; }

    /**
     * Liefert die Normalkraft der Bemessung [MN]
     * @return die maximale Normalkraft im Querschnitt in [MN]
     */
    public double getN(){ return n; }

    /**
     * Setzt die Normalkraft der Bemessung [MN]
     * @param n die maximale Normalkraft im Querschnitt in [MN]
     */
    public void setN(double n){ this.n = n; }

    /**
     * Liefert die Querkraft der Bemessung [MN]
     * @return die maximale Querkraft im Querschnitt in [MN]
     */
    public double getQ(){ return q; }

    /**
     * Setzt die Querkraft der Bemessung [MN]
     * @param q die maximale Querkraft im Querschnitt in [MN]
     */
    public void setQ(double q){ this.q = q; }

	/**
     * Liefret die Lnge des Bauteils in [m]
     */
    public double getL(){ return l; }

	/**
     * Setzt die Lnge des Bauteils in [m]
     * @param lnge des Bauteils im [m]
     */
    public void setL(double l){ this.l = l; }

    /**
     * Liefert die statische Hhe des Querschnitts in [m]
     * @return statische Hhe des Querschnitts in [m]
     */
    public double getH(){ return h; }

    /**
     * Setzt die statische Hhe des Querschnitts in [m]
     * @param h statische Hhe des Querschnitts in [m]
     */
    public void setH(double h){ this.h = h; }

     /**
     * Liefert die Betondeckung des Querschnitts in [m]
     * @return d1 Betondeckung des Querschnitts in [m]
     */
    public double getD1(){ return d1; }
     /**
     * Setzt die Betondeckung des Querschnitts in [m]
     * @param d1 Betondeckung des Querschnitts in [m]
     */
    public void setD1(double d1){ this.d1 = d1; }

    /**
     * Liefert die Breite des Querschnitts in [m]
     * @return Breite des Querschnitts in [m]
     */
    public double getB(){ return b; }

    /**
     * Setzt die Breite des Querschnitts in [m]
     * @param b Breite des Querschnitts in [m]
     */
    public void setB(double b){ this.b = b; }

    /**
     * Liefert die Bezeichnung des Betons
     * @return Bezeichnung des Betons
     */
    public String getBeton(){ return beton; }

    /**
     * Setzt die Bezeichnung des Betons nach DIN 1045-1
     * @param beton erlaubt sind folgende Werte: [C12/15 ; C16/20 ; C20/25 ; ... ; C100/115]
     */
    public void setBeton(String beton){ this.beton = beton; }

  	public synchronized void addPropertyChangeListener(PropertyChangeListener listener){
        propertyChangeSupport.addPropertyChangeListener(listener);
    }

    public synchronized void removePropertyChangeListener(PropertyChangeListener listener){
        propertyChangeSupport.removePropertyChangeListener(listener);
    }

    /**
     * Hier wird dem Bean mitgeteilt, dass es nun die Schnittgren
     * ermitteln soll
     * @param ev ein abgefeuerter ActionEvent
     */
    public void actionPerformed(ActionEvent ev){
		/**
         * Wenn eine Knickuntersuchung ntig ist, werden die
         * Bemessungsgren nach dem Modellsttzenverfahren
         * ermittelt
         */
        if(this.isKnick())
            accept(new Knickuntersuchung());
        accept(new Druckbewehrung());
        accept(new Schubbewehrung());

    }

    public void accept(BewehrungsVisitor visitor){
        try{
            visitor.visitStuetzenBean(this);
        }catch(Exception e){
            System.out.println(e.toString());
        }
        }

    public double getGammaC(){ return gammaC; }

    public void setGammaC(double gammaC){ this.gammaC = gammaC; }

    public double getGammaS(){ return gammaS; }

    public void setGammaS(double gammaS){ this.gammaS = gammaS; }

	/**
     * Liefert die Streckgrenze des Baustahls in [MN/m^2]
     * @return Streckgrenze des Baustahls in [MN/m^2]
     */
    public double getFyk(){ return fyk; }

	/**
     * Setzt die Streckgrenze des Baustahls in [MN/m^2]
     * @param fvd Streckgrenze des Baustahls in [MN/m^2]
     */
    public void setFyk(double fyk){ this.fyk = fyk; }

    /**
     * Liefert die ntige Zugbewehrung in [m^2]
     * @return ntige Zugbewehrung in [m^2/m]
     */
    public double getAz(){ return az; }

    /**
     * Setzt die ntige Zugbewehrung in [m^2]
     * @param aq ntige Zugbewehrung in [m^2]
     */
    public void setAz(double az){
        double oldAz = getAz();
        this.az = az;
        propertyChangeSupport.firePropertyChange("az", new Double(oldAz), new Double(az));
    }

    /**
     * Liefert die ntige Schubbewehrung in [m^2/m]
     * @return ntige Schubbewehrung in [m^2/m]
     */
    public double getAq(){ return aq; }

    /**
     * Setzt die ntige Schubbewehrung je Lngeneinheit [m^2/m]
     * @param aq ntige Schubbewehrung je Lngeneinheit in [m^2/m]
     */
    void setAq(double aq){
        double oldAq = getAq();
        this.aq = aq;
        propertyChangeSupport.firePropertyChange("aq", new Double(oldAq), new Double(aq));
    }

    /**
     * Gibt auskunft darber, ob eine Knickuntersuchung fr den
     * Eulerfall II durchgefhrt wird oder nicht
     * @return true   Knickuntersuchung wird durchgefhrt
     * @return false  Knickuntersuchung wird nicht durchgefhrt
     */
    public boolean isKnick(){ return knick; }

    /**
     * Hier wird festgesetzt, ob eine Knickuntersuchung fr den
     * Eulerfall II durchgefhrt wird oder nicht
     * @param true  Knickuntersuchung wird durchgefhrt
     * @param false Knickuntersuchung wird nicht durchgefhrt
     */
    public void setKnick(boolean knick){ this.knick = knick; }
}
