/* Generated by Together */

package bemessung.eckverbindungen;

import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * Dieses Bean bemisst eine Biegesteife geschraubte Eckverbindung zweier I-Profiele. 
 * Die Classe kommuniziert ber ihre getter und setter 
 * Den Ansto zur Berrechnung erreicht man ber einen ActionEvent
 * @author Johannes Hhne 
 */
public class BiegesteifBean implements Serializable, Element  {

public BiegesteifBean(){}

    private void writeObject(ObjectOutputStream oos) throws IOException {
        // Write the non-static and non-transient fields of the current class to this stream
        oos.defaultWriteObject();
    }

    public void actionPerformed(ActionEvent ev) {
        accept(new Bemessung());
    }

    private void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException {
        // Read the non-static and non-transient fields of the current class from this stream
        ois.defaultReadObject();
    }

    public void accept(Visitor visitor){
            visitor.visitBiegesteifBean(this);
        }

    public synchronized void addPropertyChangeListener(PropertyChangeListener listener){
        propertyChangeSupport.addPropertyChangeListener(listener);
    }

    public synchronized void removePropertyChangeListener(PropertyChangeListener listener){
        propertyChangeSupport.removePropertyChangeListener(listener);
    }


	/**
     * Liefert die Normalkraft im Riegel in [MN]
     * @return Normalkraft im Riegel in [MN]
     */
	public double getN_r(){ return n_r; }

    /**
     * Setzt die Normalkraft im Riegel in [MN]
     * @param n_r Normalkraft im Riegel in [MN]
     */
    public void setN_r(double n_r){ this.n_r = n_r; }

    /**
     * Liefert das Moment im Riegel in [MNm]
     * @return Moment im Riegel in [MNm]
     */
    public double getM_r(){ return m_r; }

    /**
     * Setzt das Moment im Riegel in [MNm]
     * @param m_r Moment im Riegel in [MNm]
     */
    public void setM_r(double m_r){ this.m_r = m_r; }

    /**
     * Liefert die Querkraft im Riegel in [MN]
     * @return Querkraft im Riegel in [MN]
     */
    public double getQ_r(){ return q_r; }

    /**
     * Setzt die Querkraft im Riegel in [MN]
     * @param q_r Querkraft im Riegel in [MN]
     */
    public void setQ_r(double q_r){ this.q_r = q_r; }

    /**
     * Liefert die Neigung des Riegels in Delt Y / Delta X [1/1]
     * @return 0 Entspricht einem Flachdach
     *         Werte kleiner Null bedeuten, das die Dachneigung fllt
     *         Wete grer Null bedeuten, das die Dachneigung steigt
     */
    public double getAlpha(){ return alpha; }

    /**
     * Setzt die Neigung des Riegels in Delt Y / Delta X [1/1]
     * @param 0 Entspricht einem Flachdach
     * Werte kleiner Null bedeuten, das die Dachneigung fllt
     * Wete grer Null bedeuten, das die Dachneigung steigt
     */
    public void setAlpha(double alpha){ this.alpha = alpha; }

    /**
     * Liefert die I-Profilhhe des Riegels in [mm]
     * @return I-Profilhhe des Riegels in [mm]
     */
    public double getH_r(){ return h_r; }

    /**
     * Setzt die I-Profilhhe des Riegels in [mm]
     * @param I-Profilhhe des Riegels in [mm]
     */
    public void setH_r(double h_r){ this.h_r = h_r; }

    /**
     * Liefert die I-Profilhhe des Stiels  in [mm]
     * @return die I-Profilhhe des Stiels  in [mm]
     */
    public double getH_s(){ return h_s; }

    /**
     * Setzt die I-Profilhhe des Stiels  in [mm]
     * @param die I-Profilhhe des Stiels  in [mm]
     */
    public void setH_s(double h_s){ this.h_s = h_s; }

    /**
     * Liefert die Flanschdicke der Riegels in [mm]
     * @return die Flanschdicke der Riegels in [mm]
     */
    public double getT_r(){ return t_r; }

    /**
     * Setzt die Flanschdicke der Riegels in [mm]
     * @param t_r die Flanschdicke der Riegels in [mm]
     */
    public void setT_r(double t_r){ this.t_r = t_r; }

    /**
     * Liefert die Flanschbreite der Riegels in [mm]
     * @return die Flanschbreite der Riegels in [mm]
     */
    public double getB_r(){ return b_r; }

    /**
     * Setzt die Flanschbreite der Riegels in [mm]
     * @param die Flanschbreite der Riegels in [mm]
     */
    public void setB_r(double b_r){ this.b_r = b_r; }

    /**
     * Liefert die Anzahl der Schrauben pro Achse
     * @return Anzahl der Schrauben pro Achse
     */
    public int getN(){ return n; }

    /**
     * Setzt Anzahl der Schrauben pro Achse
     * @param n Anzahl der Schrauben pro Achse
     */
    public void setN(int n){ this.n = n; }

    /**
     * Liefert die Schraubenbezeichnung M12 , M16 ... M36
     * @return Schraubenbezeichnung M12 , M16 ... M36
     */
    public String getD_schr(){ return d_schr; }

    /**
     * Setzt die Schraubenbezeichnung M12 , M16 ... M36
     * @param Schraubenbezeichnung M12 , M16 ... M36
     */
    public void setD_schr(String d_schr){ this.d_schr = d_schr; }

    /**
     * Liefert den Lochdurchmesser in [mm]
     * @return den Lochdurchmesser in [mm]
     */
    public double getD(){ return d; }

    /**
     * Setzt den Lochdurchmesser in [mm]
     * @param d den Lochdurchmesser in [mm]
     */
    public void setD(double d){ this.d = d; }

    /**
     * Liefert den Beilegscheibendurchmesser in [mm]
     * @return Beilegscheibendurchmesser in [mm]
     */
    public double getD_sch(){ return d_sch; }

    /**
     * Setzt den Beilegscheibendurchmesser in [mm]
     * @param d_sch Beilegscheibendurchmesser in [mm]
     */
    public void setD_sch(double d_sch){ this.d_sch = d_sch; }

    /**
     * Liefert die Dicke der Stirnplatte in [mm]
     * @return die Dicke der Stirnplatte in [mm]
     */
    public double getD_pl(){ return d_pl; }

    /**
     * Setzt die Dicke der Stirnplatte in [mm]
     * @param die Dicke der Stirnplatte in [mm]
     */
    public void setD_pl(double d_pl){ this.d_pl = d_pl; }

    /**
     * Liefert der obere Schraubenabstand in [mm]
     * @return der obere Schraubenabstand in [mm]
     */
    public double getE4(){ return e4; }

    /**
     * Setzt der obere Schraubenabstand in [mm]
     * @param der obere Schraubenabstand in [mm]
     */
    public void setE4(double e4){ this.e4 = e4; }

    /**
     * Liefert den unteren berstand der Strirnplatte in [mm]
     * @ return den unteren berstand der Strirnplatte in [mm]
     */
    public double getUe(){ return ue; }

    /**
     * Setzt den unteren berstand der Strirnplatte in [mm]
     * @param ue den unteren berstand der Strirnplatte in [mm]
     */
    public void setUe(double ue){ this.ue = ue; }

    /**
     * Liefert den Teilsicherheitsbeiwert gamma(M)
     * @return gammaM - Teilsicherheitsbeiwert gamma(M)
     */
    public double getGammaM(){ return gammaM; }

    /**
     * Setzt den Teilsicherheitsbeiwert gamma(M)
     * @param gammaM - Teilsicherheitsbeiwert gamma(M)
     */
    public void setGammaM(double gammaM){this.gammaM = gammaM; }

    /**
     * Liefert die Streckgrenze des Trgers in [MN/m^2]
     * @return die Streckgrenze des Trgers in [MN/m^2]
     */
    public double getFyk(){ return fyk; }

    /**
     * Setzt die Streckgrenze des Trgers in [MN/m^2]
     * @param fyk - die Streckgrenze des Trgers in [MN/m^2]
     */
    public void setFyk(double fyk){ this.fyk = fyk; }

    /**
     * Liefert die Auslastung der Flansche in [/]
     * @return die Auslastung der Flansche in [/]
     */
    public double getTragFlansch(){ return tragFlansch; }

    /**
     * Setzt die Auslastung der Flansche in [/]
     * @param tragFlansch - die Auslastung der Flansche in [/]
     * <= 0 Trgt
     * > 0 Flansch versagt
     */
    public void setTragFlansch(double tragFlansch){
        double oldTragFlansch = getTragFlansch();
        this.tragFlansch = tragFlansch;
        propertyChangeSupport.firePropertyChange("tragFlansch", new Double(oldTragFlansch), new Double(tragFlansch));
    }

    /**
     * Liefert die Auslastung der Querkraft in [/]
     * @return die Auslastung der Querkraft in [/]
     */
    public double getTragQuer(){ return tragQuer; }

    /**
     * Setzt die Auslastung der Querkraft in [/]
     * @param tragQuer - die Auslastung der Querkraft in [/]
     * <= 0 trgt
     * > 0 versagt
     */
    public void setTragQuer(double tragQuer){
        double oldTragQuer = getTragQuer();
        this.tragQuer = tragQuer;
        propertyChangeSupport.firePropertyChange("tragQuer", new Double(oldTragQuer), new Double(tragQuer));
    }

	/**
     * Normalkraft im Riegel in [MN]
     */
    private double n_r;
	/**
     * Moment im Riegel in [MNm]
     */
    private double m_r;
    /**
     * Querkraft im Riegel in [MN]
     */
    private double q_r;

    /**
     * Neigung des Riegels
     */
    private double alpha;
    /**
     * die I-Profilhhe des Riegels in [mm]
     */
    private double h_r;
    /**
     * die I-Profilhhe des Stiels  in [mm]
     */
    private double h_s;
	/**
     * Die Flanschdicke des Riegels in [mm]
     */
    private double t_r;
	/**
     * die Flanschbreite der Riegels in [mm]
     */
    private double b_r;
	/**
     * Anzahl der Schrauben pro Achse
     */
    private int n;
    /**
     * Schraubenbezeichnung M12 , M16 ... M36
     */
    private String d_schr;

	/**
     * der Lochdurchmesser in [mm]
     */
    private double d;
    /**
     * Beilegscheibendurchmesser in [mm]
     */
    private double d_sch;
    /**
     * die Dicke der Stirnplatte in [mm]
     */
    private double d_pl;
    /**
     * der obere Schraubenabstand in [mm]
     */
    private double e4;
	/**
     * Der berstand der Strirnplatte in [mm]
     */
    private double ue;
	/**
     * Teilsicherheitsbeiwert gamma(M)
     */
    private double gammaM;
	/**
     * Streckgrenze f(y,k) in [MN/m^2]
     */
    private double fyk;
    /**
     * Die Auslastung der Flansche in [/]
     */
    private double tragFlansch;
	/**
     * die Auslastung der Querkraft in [/]
     */
    private double tragQuer;
    private PropertyChangeSupport propertyChangeSupport = new java.beans.PropertyChangeSupport(this);
}
