/* Generated by Together */

package bemessung.stahltraeger;

import java.io.ObjectOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.awt.event.ActionListener;
import java.util.Vector;
import java.awt.event.ActionEvent;

/**
 * Dieses Bean bemisst einen Stahltrger. Dabei mssen ihm alle ntigen Daten
 * einzeln bergeben werden, da es nicht von Objekten wie zum Beispiel
 * I_Profil abhngig sein soll. Dadurch erreicht man eine grere
 * Protabilitt und kann es in einer fremden Beanumgebung ohne
 * Adapter laufen lassen.
 * ber die setter Methoden lt sich das Bean bestcken, wobei es sich dringend
 * empfielt alle setter zu bedienen, da nicht geprft wird, ob die
 * Eingangswerte korrekt sind oder nicht.
 * ber die Methode actionPerformed schiet man dann einen Event in das Objekt
 * und lst somit die Berechnung aus.
 * ber die fertige Berrechnung wird man informiert, wenn man sich am
 * Bean angemeldet hat addPropertyChangeListener(PropertyChangeListener listener)
 * @author Johannes Hhne
 * geprft und fr gut befunden
 */
public class BalkenBean implements Serializable, ActionListener, Element {
    /**
     * Liefert die eingeprgte Normalkraft des Trgers in [MN]
     * @return die eingeprgte Normalkraft des Trgers in [MN]
     */
    public double getN(){ return n; }

    /**
     * Setzt die eingeprgte Normalkraft des Trgers in [MN]
     * @param n - die eingeprgte Normalkraft des Trgers in [MN]
     */
    public void setN(double n){ this.n = n; }

    /**
     * Liefert das eingeprgte Moment des Trgers in [MN]
     * @return das eingeprgte Moment des Trgers in [MN]
     */
    public double getM(){ return m; }

    /**
     * Setzt das eingeprgte Moment des Trgers in [MN]
     * @param m - das eingeprgte Moment des Trgers in [MN]
     */
    public void setM(double m){ this.m = m; }

    /**
     * Liefert die eingeprgte Querkraft des Trgers in [MN]
     * @return die eingeprgte Querkraft des Trgers in [MN]
     */
    public double getQ(){ return q; }

    /**
     * Setz die eingeprgte Querkraft des Trgers in [MN]
     * @param q - die eingeprgte Querkraft des Trgers in [MN]
     */
    public void setQ(double q){ this.q = q; }

    /**
     * Setzt die Lnge des Trgers in [m]
     * @param l - Lnge in [m]
     */
    public double getL(){ return l; }

    /**
     * Liefert die Lnge des Trgers in [m]
     * @return die Lnge des Trgers in [m]
     */
    public void setL(double l){ this.l = l; }

    /**
     * Liefert Flche des Profils in {cm^2]
     * @return Flche des Profils in {cm^2]
     */
    public double getA(){ return a; }

    /**
     * Setzt die Flche des Profils in {cm^2]
     * @param a - Flche des Profils in {cm^2]
     */
    public void setA(double a){ this.a = a; }

    /**
     * Liefert die Breite des Profiels in [mm]
     * @return Breite in [mm]
     */
    public double getB(){ return b; }

    /**
     * Setzt die Breite des Profiels in [mm]
     * @param h - Breite in [mm]
     */
    public void setB(double b){ this.b = b; }

    /**
     * Liefert die Hhe des Profiels in [mm]
     * @return Hhe in [mm]
     */
    public double getH(){ return h; }

    /**
     * Setzt die Hhe des Profiels in [mm]
     * @param h - Hhe in [mm]
     */
    public void setH(double h){ this.h = h; }

    /**
     * Liefert die Dicke der Flansche in [mm]
     * @return Dicke der Flansche in [mm]
     */
    public double getT(){ return t; }

    /**
     * Setzt die Dicke der Flansche in [mm]
     * @param t - Dicke in [mm]
     */
    public void setT(double t){ this.t = t; }

    /**
     * Liefert den Innenradius zwischen Flansch und Steg in [mm]
     * @return innenradius in [mm]
     */
    public double getR(){ return r; }

    /**
     * Setzt den Innenradius zwischen Flansch und Steg in [mm]
     * @param r - Innenradius in [mm]
     */
    public void setR(double r){ this.r = r; }

    /**
     * Liefert die Stegdicke in [mm]
     * @return die Stegdicke in [mm]
     */
    public double getS(){ return s; }

    /**
     * Setzt die Stegdicke in [mm]
     * @param s - die Stegdicke in [mm]
     */
    public void setS(double s){ this.s = s; }

	/**
     * Liefert vorh(b/h) des I_Profiels
     * @return vorh(b/h) in [/]
     */
    public double getB_t_vorhanden(){ return b_t_vorhanden; }

    /**
     * Setzt vorh(b/h) des I-Profils
     * @param b_t_vorhanden - Wert aus der Tabelle
     */
    public void setB_t_vorhanden(double b_t_vorhanden){ this.b_t_vorhanden = b_t_vorhanden; }

    /**
     * Liefert das Flchentrgheitsmoment in Z-Richtung 2. Grades in [cm^4]
     * @return das Flchentrgheitsmoment in Z-Richtung 2. Grades in [cm^4]
     */
    public double getIz(){ return iz; }

    /**
     * Setzt das Flchentrgheitsmoment in Z-Richtung  2. Grades in [cm^4]
     * @param i - das Flchentrgheitsmoment in Z-Richtung  2. Grades in [cm^4]
     */
    public void setIz(double iz){ this.iz = iz; }

    /**
     * Liefert das Flchentrgheitsmoment 2. Grades in y-Richtung  in [cm^4]
     * @return das Flchentrgheitsmoment 2. Grades in y-Richtung  in [cm^4]
     */
    public double getIy(){ return iy; }

    /**
     * Setzt das Flchentrgheitsmoment 2. Grades in y-Richtung  in [cm^4]
     * @param i - das Flchentrgheitsmoment 2. Grades in y-Richtung  in [cm^4]
     */
    public void setIy(double iy){ this.iy = iy; }

    /**
     * Liefert das plastische WiederstandsmomentW(pl,y) in cm^3
     * @return das plastische WiederstandsmomentW(pl,y) in cm^3
     */
    public double getWply(){ return wply; }

    /**
     * Setzt das plastische WiederstandsmomentW(pl,y) in cm^3
     * @param wply - das plastische WiederstandsmomentW(pl,y) in cm^3
     */
    public void setWply(double wply){ this.wply = wply; }

    /**
     * Liefert den Trgheitsradius bezogen auf die y-Achse in [cm]
     * @return Trgheitsradius bezogen auf die y-Achse in [cm]
     */
    public double getIyRad(){ return iyRad; }

    /**
     * Setzt den Trgheitsradius bezogen auf die y-Achse in [cm]
     * @param iyRad - Trgheitsradius bezogen auf die y-Achse in [cm]
     */
    public void setIyRad(double iyRad){ this.iyRad = iyRad; }

    /**
     * Liefert den E-Modul des Trgers im [MN/m^2]
     * @return E-Modul des Trgers im [MN/m^2]
     */
    public int getE(){return e; }

    /**
     * Setzt den E-Modul des Trgers im [MN/m^2]
     * @param e - E-Modul des Trgers im [MN/m^2]
     */
    public void setE(int e){this.e = e;}

    /**
     * Liefert die Streckgrenze des Trgers in [MN/m^2]
     * @return die Streckgrenze des Trgers in [MN/m^2]
     */
    public int getFyk(){return fyk;}

    /**
     * Setzt die Streckgrenze des Trgers in [MN/m^2]
     * @param fyk - die Streckgrenze des Trgers in [MN/m^2]
     */
    public void setFyk(int fyk){this.fyk = fyk;}

    /**
     * Liefert die Knickspannungslinie a, b, c oder d senkrecht
     * zur z Achse
     * @return a, b, c oder d
     */
    public String getKsl_zz(){ return ksl_zz; }

    /**
     * Setzt die Knickspannungslinie a, b, c oder d senkrecht
     * zur z Achse
     * @param ksl - a, b, c oder d
     */
    public void setKsl_zz(String ksl_zz){ this.ksl_zz = ksl_zz; }

    /**
     * Liefert die Knickspannungslinie a, b, c oder d senkrecht
     * zur y Achse
     * @return a, b, c oder d
     */
    public String getKsl_yy(){ return ksl_yy; }

    /**
     * Setzt die Knickspannungslinie a, b, c oder d senkrecht
     * zur y Achse
     * @param ksl - a, b, c oder d
     */
    public void setKsl_yy(String ksl_yy){ this.ksl_yy = ksl_yy; }

    /**
     * Liefert den Teilsicherheitsbeiwert gamma(M)
     * @return gammaM - Teilsicherheitsbeiwert gamma(M)
     */
    public double getGammaM(){ return gammaM; }

    /**
     * Setzt den Teilsicherheitsbeiwert gamma(M)
     * @param gammaM - Teilsicherheitsbeiwert gamma(M)
     */
    public void setGammaM(double gammaM){this.gammaM = gammaM; }

    /**
     * Setzt den Teilsicherheitsbeiwert gamme(M)
     * @param gammaM - Teilsicherheitsbeiwert gamma(M)
    public void setGammaM(double gammaM){ this.gammaM = gammaM; }

	/**
     * Liefert die Auslastung des Trgers beim Spannungsnachweis in [/]
     * @return die Auslastung des Trgers beim Spannungsnachweis in [/] -1 wenn vorh(b/h) > grenz(b/h) ist
     */
    public double getSpannungsNachweis(){ return spannungsNachweis; }

    /**
     * Setzt die Auslastung des Trgers beim Spannungsnachweis in [/]
     * @param spannungsNachweis - die Auslastung des Trgers beim Spannungsnachweis in [/]
     */
    public void setSpannungsNachweis(double spannungsNachweis){
        double oldSpannungsNachweis = getSpannungsNachweis();
        this.spannungsNachweis = spannungsNachweis;
        propertyChangeSupport.firePropertyChange("spannungsNachweis", new Double(oldSpannungsNachweis),
            new Double(spannungsNachweis));
    }

	/**
     * Liefert die Auslastung des Trgers beim Biegenachweis in [/]
     * @return die Auslastung des Trgers beim Biegenachweis in [/]
     */
    public double getBiegeNachweis(){ return biegeNachweis; }

    /**
     * Setzt die Auslastung des Trgers beim Biegenachweis in [/]
     * @param spannungsNachweis - die Auslastung des Trgers beim Biegenachweis in [/]
     */
    public void setBiegeNachweis(double biegeNachweis){
        double oldBiegeNachweis = getBiegeNachweis();
        this.biegeNachweis = biegeNachweis;
        propertyChangeSupport.firePropertyChange("biegeNachweis", new Double(oldBiegeNachweis), new Double(biegeNachweis));
    }

	/**
     * Liefert die Auslastung des Trgers beim Drillknicknachweis in [/]
     * @return die Auslastung des Trgers beim Drillknicknachweis in [/]
     */
    public double getDrillNachweis(){ return drillNachweis; }

    /**
     * Setzt die Auslastung des Trgers beim Drillknicknachweis in [/]
     * @param spannungsNachweis - die Auslastung des Trgers beim Drillknicknachweis in [/]
     */
    public void setDrillNachweis(double drillNachweis){
        double oldDrillNachweis = getDrillNachweis();
        this.drillNachweis = drillNachweis;
        propertyChangeSupport.firePropertyChange("drillNachweis", new Double(oldDrillNachweis), new Double(drillNachweis));
    }

	/**
     * Gibt an, ob ein Biegeknicknachweis durchgefhrt wird oder nicht
     * @return true Nachweis wird durchgefhrt false Nachweis wird nicht durchgefhrt
     */
    public boolean isBiegeTest(){ return biegeTest; }

    /**
     * Mit dieser Methode kann ein Biegeknicknachweis angefordert werden
     * @param true Nachweis wird durchgefhrt
     * @param false Nachweis wird nicht durchgefhrt
     */
    public void setBiegeTest(boolean biegeTest){ this.biegeTest = biegeTest; }

	/**
     * Gibt an, ob ein Stabilittsnachweis durchgefhrt wird oder nicht
     * @return true Nachweis wird durchgefhrt false Nachweis wird nicht durchgefhrt
     */
    public boolean isDrillTest(){ return drillTest; }

    /**
     * Mit dieser Methode kann ein Stabilittsnachweis angefordert werden
     * @param stabilTest - true Nachweis wird durchgefhrt
     * @param stabilTest - false Nachweis wird nicht durchgefhrt
     */
    public void setDrillTest(boolean drillTest){ this.drillTest = drillTest; }

    public void actionPerformed(ActionEvent ev) {
        accept(new Spannungsnachweis());
        if (biegeTest)
            accept(new Biegeknicken());
        if (drillTest)
            accept(new Drillknicken());
    }

   	public BalkenBean(){}

   /**
    * Meldestelle fr Interessierte
    * @param listener - Listener der angemeldet werden soll.
    */
    public synchronized void addPropertyChangeListener(PropertyChangeListener listener){
        propertyChangeSupport.addPropertyChangeListener(listener);
    }

    /**
     * Abmeldestelle fr nicht mehr Interessierte
     * @param listener - Listener der angemeldet werden soll.
     */
    public synchronized void removePropertyChangeListener(PropertyChangeListener listener){
        propertyChangeSupport.removePropertyChangeListener(listener);
    }

    public void accept(NachweisVisitor visite) {
        visite.visiteBalkenBean(this);
    }

	/**
     * Normalkraft N(d)
     */
    private double n;

	/**
     * Moment M(d)
     */
    private double m;

	/**
     * Querkraft Q(d)
     */
    private double q;

	/**
     * Lnge des Trgers
     */
    private double l;
	/**
     * Flche des Profils in {cm^2]
     */
    private double a;

	/**
     * Breite des Profiels
     */
    private double b;

	/**
     * Hhe des Profiels
     */
    private double h;

	/**
     * Flanschdicke
     */
    private double t;

	/**
     * Innenradius
     */
    private double r;

	/**
     * Stegdicke
     */
    private double s;

	/**
     * vorh(b/h)
     */
    private double b_t_vorhanden;

	/**
     * Flchentrgheit in z-Richtung
     */
    private double iz;

	/**
     * Flchentrgheit in y-Richtung
     */
    private double iy;

	/**
     * W(pl,y)
     */
    private double wply;

	/**
     * Trgheitsradius bezogen auf die y-Achse in [cm]
     */
    private double iyRad;

	/**
     * E-Modul
     */
    private int e;
	/**
     * Streckgrenze f(y,k)
     */
    private int fyk;

	/**
     * Knickspannungslinie a, b, c oder d senkrecht
     * zur z Achse
     */
    private String ksl_zz;

	/**
     * Knickspannungslinie a, b, c oder d senkrecht
     * zur y Achse
     */
    private String ksl_yy;

	/**
     * Teilsicherheitsbeiwert gamma(M)
     */
    private double gammaM;

	/**
     * Auslastung des Querschnitts beim Spannungsnachweis
     */
    private double spannungsNachweis;
	/**
     * Auslastung des Querschnitts beim Biegeknicknachweis
     */
    private double biegeNachweis;

    /**
         * Auslastung des Querschnitts beim Drillknicknachweis
         */
    private double drillNachweis;

	/**
     * Soll ein Biegeknicknachweis gefhrt werden oder nicht
     */
    private boolean biegeTest;

	/**
	 * Soll ein Drillknicknachweis gefhrt werden oder nicht
     */
    private boolean drillTest;
    private PropertyChangeSupport propertyChangeSupport = new java.beans.PropertyChangeSupport(this);
}
