/* Generated by Together */

package bemessung.stahltraeger;

/**
 * Fhrt den Nachweis fr Biegeknicken.. Dabei wird allerdings nur der Eulerfall
 * 2 bercksichtigt. Dies ist desshalb so entschieden worden, da alle anderen
 * knickfiguren durch das Drehwinkelverfahren abgesichert sind.
 * @author Johannes Hhne
 * geprft und fr gut befunden
 */
class Biegeknicken implements NachweisVisitor {
    public void visiteBalkenBean(BalkenBean balken){
		//vorgegebene Werte
        double gamma 	= balken.getGammaM();
		double N     	= balken.getN();
        double M		= balken.getM();
        double V		= balken.getQ();
        double fyk    	= balken.getFyk();
        double e		= balken.getE();
        double sk		= balken.getL()*100;
        double h		= balken.getH();
        double t		= balken.getT();
        double r		= balken.getR();
        double s		= balken.getS();
        double vorhBT	= balken.getB_t_vorhanden();
        double Wpl		= balken.getWply();
        double iyRad	= balken.getIyRad();
		double A		= balken.getA();
        String ksl		= balken.getKsl_yy();

		//zu errechnende Gren
        //plastische Grenzbelastungen in [MN] oder [MNm]
		double Vpl		= V >= 0.0 ? fyk/(gamma*Math.sqrt(3))*(h-t)*s / 1000000 :
            				(-1.0)*fyk/(gamma*Math.sqrt(3))*(h-t)*s / 1000000;
        double Mpl		= M >= 0.0 ? fyk/gamma * Wpl*1000 / 1000000 /1000 :
            				(-1.0)*fyk/gamma * Wpl*1000 / 1000000 /1000;
        double Npl		= N >= 0.0 ? fyk/gamma * A*100 / 1000000:
            				(-1.0)*fyk/gamma * A*100 / 1000000;
        double lam = sk/(iyRad*Math.PI*Math.sqrt(e/fyk));
        double a = -1.0;
        if(ksl.equals("a"))
            a = 0.21;
        if(ksl.equals("b"))
            a = 0.34;
        if(ksl.equals("c"))
            a = 0.49;
        if(ksl.equals("d"))
            a = 0.76;
        double k = -1.0;
        if(lam<=0.2)
            k = 1.0;
        if(lam>0.2 && lam<=3.0){
            double f1 = 0.5*(1+a*(lam-0.2)+lam*lam);
            k = 1.0/( f1  + Math.sqrt(f1*f1-lam*lam));
        }
        if(lam>3.0)
            k=1.0/(lam*(lam+a));
        balken.setBiegeNachweis(N/(k*Npl)+M/Mpl+0.1);

    }
}
