/* Generated by Together */

package bemessung.stahltraeger;

/**
 * Fhrt den Nachweis fr Biegedrillknicken.. Dabei wird allerdings nur der
 * Eulerfall 2 bercksichtigt. Dies ist desshalb so entschieden worden,
 * da alle anderen knickfiguren durch das Drehwinkelverfahren abgesichert sind.
 * @author Johannes Hhne
 * getestet und fr gut befunden
 */
class Drillknicken implements NachweisVisitor {
    public void visiteBalkenBean(BalkenBean balken){
		//vorgegebene Werte
        double gamma 	= balken.getGammaM();
		double N     	= balken.getN();
        double M		= balken.getM();
        double V		= balken.getQ();
        double fyk    	= balken.getFyk();
        double e		= balken.getE();
        double sk		= balken.getL()*100;
        double h		= balken.getH();
        double t		= balken.getT();
        double b		= balken.getB();
        double r		= balken.getR();
        double s		= balken.getS();
        double vorhBT	= balken.getB_t_vorhanden();
        double Wpl		= balken.getWply();
        double Iz		= balken.getIz();
        double Iy		= balken.getIy();
		double A		= balken.getA();
        String ksl		= balken.getKsl_zz();

		//zu errechnende Gren
        //plastische Grenzbelastungen in [MN] oder [MNm]
		double Vpl		= V >= 0.0 ? fyk/(gamma*Math.sqrt(3))*(h-t)*s / 1000000 :
            				(-1.0)*fyk/(gamma*Math.sqrt(3))*(h-t)*s / 1000000;
        double Mpl		= M >= 0.0 ? fyk/gamma * Wpl*1000 / 1000000 /1000 :
            				(-1.0)*fyk/gamma * Wpl*1000 / 1000000 /1000;
        double Npl		= N >= 0.0 ? fyk/gamma * A*100 / 1000000:
            				(-1.0)*fyk/gamma * A*100 / 1000000;
        //kz wird bestimmt
        double lam = Math.sqrt(Math.abs(Npl)*gamma*sk*sk*10000/(Math.PI*Math.PI*e*Iz));

        double a = -1.0;
        if(ksl.equals("a"))
            a = 0.21;
        if(ksl.equals("b"))
            a = 0.34;
        if(ksl.equals("c"))
            a = 0.49;
        if(ksl.equals("d"))
            a = 0.76;

        double kz = -1.0;
        if(lam<=0.2)
            kz = 1.0;
        if(lam>0.2 && lam<=3.0){
            double f1 = 0.5*(1+a*(lam-0.2)+lam*lam);
            kz = 1.0/( f1  + Math.sqrt(f1*f1-lam*lam));
        }
        if(lam>3.0)
            kz=1.0/(lam*(lam+a));


        //kM wird bestimmt
        double lamM = Math.sqrt(Mpl*1000000*sk*h*h*gamma/(1.32*b*t*e*Iy));
		double kM = lamM <= 0.4 ? 1.0 : Math.pow((1/(1+lamM*lamM*lamM*lamM*lamM)),(0.4));
        //ky wird berechnet
        double ky = 1-N*(0.15*lam*1.1-0.15)/(kz*Npl);

        //Nachweis
        balken.setDrillNachweis(N/(kz*Npl) + M*ky/(kM*Mpl));
    }

}
