/* Generated by Together */

package gui;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import java.util.Vector;
import javax.swing.JOptionPane;
import rahmen.RahmenFactory;
import rahmen.Rahmen;
import rahmen.Wind;
import javax.swing.JTabbedPane;
import javax.swing.JScrollPane;
import java.awt.event.ActionEvent;
import rahmen.LinkerStiel;
import rahmen.Keller;
import rahmen.RechterStiel;
import rahmen.Riegel;
import java.beans.PropertyVetoException;
import java.beans.VetoableChangeListener;
import javax.swing.JPanel;
import java.awt.GridLayout;

/**
 * Kontrolliert die einzelnen Panele 
 */
class GUIControl {
	/**
     * Statische Klasse um eine Instanz der GUIControll
     * zu bekommen
     */
    static GUIControl getGUIControll(){
        if(control == null){
            control = new GUIControl();
        }
        return control;
    }


    /**
     * Der Konstruktor mu von auen unsichtbar sein um immer nur
     * ein Modell zu haben
     * (singelton Gof)
     */
    private GUIControl(){
		//Das Model des Rahmens mu vorkonfiguriert werden
        makeRahmenModel();
        makeGeometrie();
        makeLasten();
        updateModel();
        makeSchnitt();
    }

    /**
     * In dieser Methode wird der Geometrieteil kontrolliert
     */
    private void makeGeometrie(){
        geometrie = new JPanelGeom();
		//Ecken
        eckeLinks = geometrie.getEckeLinks();
        eckeRechts = geometrie.getEckeRechts();
		matLinks = geometrie.getMaterialLinks();
		matRechts = geometrie.getMaterialRechts();
		matOben = geometrie.getMaterialOben();
        rahmenGeom = geometrie.getRahmen();
        laengen = geometrie.getLaengen();

		//Ecken verdrahten
        //Linke Ecke
        try{
            eckeLinks.setGelenk(true);
        }catch(PropertyVetoException pve){}
		eckeLinks.addVetoableChangeListener(new VetoableChangeListener(){
			public void vetoableChange(PropertyChangeEvent ev) throws PropertyVetoException{
                    if(ev.getPropertyName().equals("gelenk")){
						boolean wert =  ((Boolean)ev.getNewValue()).booleanValue();
						if(wert &&
                          !matLinks.getMaterial().isBeton() &&
                          !matOben.getMaterial().isBeton()){
						    rahmenGeom.setGelLinks(wert);
                        }
                        else if(!wert && (
                          matLinks.getMaterial().isBeton() ||
                          matOben.getMaterial().isBeton())){
                        	JOptionPane.showMessageDialog(geometrie,
                            "Es knnen nur Stahlteile"+
                            "\nbiegesteif angeschlossen werden!" ,
                            "Option nicht untersttzt", JOptionPane.ERROR_MESSAGE);
                        	rahmenGeom.setGelLinks(true);
                            throw new PropertyVetoException("kein Stahl",ev);
                        }
                        else{
                            rahmenGeom.setGelLinks(wert);
                        }
                        updateModel();
                    }
                  }});
        //Rechte Ecke
        try{
        	eckeRechts.setGelenk(false);
        }catch(PropertyVetoException pve){}
        rahmenGeom.setGelRechts(false);
		eckeRechts.addVetoableChangeListener(new VetoableChangeListener(){
			public void vetoableChange(PropertyChangeEvent ev) throws PropertyVetoException{
                    if(ev.getPropertyName().equals("gelenk")){
						boolean wert =  ((Boolean)ev.getNewValue()).booleanValue();
						if(wert &&
                          !matRechts.getMaterial().isBeton() &&
                          !matOben.getMaterial().isBeton()){
						    rahmenGeom.setGelRechts(true);
                        }
                        else if(!wert && (
                          matRechts.getMaterial().isBeton() ||
                          matOben.getMaterial().isBeton())){
                        	JOptionPane.showMessageDialog(geometrie,
                            "Es knnen nur Stahlteile "+
                            "\nbiegesteif angeschlossen werden!" ,
                            "Option nicht untersttzt", JOptionPane.ERROR_MESSAGE);
                        	rahmenGeom.setGelRechts(true);
                            throw new PropertyVetoException("kein Stahl",ev);
                        }
                        else
                            rahmenGeom.setGelRechts(wert);
                        updateModel();
                    }
                  }});


		//Lngen verdraten
		laengen.setAbstand(6.4);
        laengen.setHKeller(3.4);
        laengen.setHStielLinks(9.7);
        laengen.setBreite(24.10);
        laengen.setHStielRechts(8.9);
        laengen.addPropertyChangeListener(new PropertyChangeListener(){
				 public void propertyChange(PropertyChangeEvent ev){
                    String prop = ev.getPropertyName();

                    if(prop.equals("hKeller")){
                        double wert = ((Double)ev.getNewValue()).doubleValue();
						//berprfung der Lngenkonsistenz
                    	if(wert < 1 || wert > 10){
                        	JOptionPane.showMessageDialog(geometrie,
                            "Das eingegebene Ma ist auerhalb"+
                            "\ndes sinnvollen Bereichts!"+
                            "\nDer Wert wird zurckgesetz."+
                            "\n\nDer Bereich liegt zwischen 1m und 10m",
                            "Falscher Wert", JOptionPane.ERROR_MESSAGE);
                            wert = ((Double)ev.getOldValue()).doubleValue();
                            laengen.setHKeller(wert);
                         }
                        rahmenGeom.setH_keller(wert);
                    }

                    if(prop.equals("hStielLinks")){
                        double wert = ((Double)ev.getNewValue()).doubleValue();
						//berprfung der Lngenkonsistenz
                    	if(wert < 3 || wert > 20){
                        	JOptionPane.showMessageDialog(geometrie,
                            "Das eingegebene Ma ist auerhalb"+
                            "\ndes sinnvollen Bereichts!"+
                            "\nDer Wert wird zurckgesetz."+
                            "\n\nDer Bereich liegt zwischen 3m und 20m",
                            "Falscher Wert", JOptionPane.ERROR_MESSAGE);
                            wert = ((Double)ev.getOldValue()).doubleValue();
                            laengen.setHStielLinks(wert);
                         }
						//berprfung der Winkelkonsistenz
                        double winkel = (laengen.getHStielLinks()-
                                         laengen.getHStielRechts()) /
                                        laengen.getBreite();
                        if(Math.abs(winkel) > 0.466){//tan(25)=0,466
							double gk  = 0.460*laengen.getBreite();
                            if(winkel <= 0.0)
                                laengen.setHStielRechts(laengen.getHStielLinks()+gk);
                            else
                                laengen.setHStielRechts(laengen.getHStielLinks()-gk);
                        	JOptionPane.showMessageDialog(geometrie,
                            "Durch die eingegebene Gre, wrde die "+
                            "\nmaximale Dachneigung von 25 berschreiten!"+
                            "\nDer rechte Stiel wird angepat.",
                            "Zu groe Dachneigung", JOptionPane.ERROR_MESSAGE);
						}
                        rahmenGeom.setH_stielLinks(wert);
					}

                    if(prop.equals("breite")){
                        double wert = ((Double)ev.getNewValue()).doubleValue();
						//berprfung der Lngenkonsistenz
                    	if(wert < 5 || wert > 40){
                        	JOptionPane.showMessageDialog(geometrie,
                            "Das eingegebene Ma ist auerhalb"+
                            "\ndes sinnvollen Bereichts!"+
                            "\nDer Wert wird zurckgesetz."+
                            "\n\nDer Bereich liegt zwischen 5m und 40m",
                            "Falscher Wert", JOptionPane.ERROR_MESSAGE);
                            wert = ((Double)ev.getOldValue()).doubleValue();
                            laengen.setBreite(wert);
                         }
						//berprfung der Winkelkonsistenz
                        double winkel = (laengen.getHStielLinks()-
                                         laengen.getHStielRechts()) /
                                        laengen.getBreite();
                        if(Math.abs(winkel) > 0.466){//tan(25)=0,466
							double gk  = 0.460*laengen.getBreite();
                            if(winkel <= 0.0)
                                laengen.setHStielLinks(laengen.getHStielRechts()-gk);
                            else
                                laengen.setHStielLinks(laengen.getHStielRechts()+gk);
                        	JOptionPane.showMessageDialog(geometrie,
                            "Durch die eingegebene Gre, wrde die "+
                            "\nmaximale Dachneigung von 25 berschreiten!"+
                            "\nDer linke Stiel wird angepat.",
                            "Zu groe Dachneigung", JOptionPane.ERROR_MESSAGE);
						}
                        rahmenGeom.setB_riegel(wert);
					}

                    if(prop.equals("hSteilRechts")){
                        double wert = ((Double)ev.getNewValue()).doubleValue();
						//berprfung der Lngenkonsistenz
                    	if(wert < 3 || wert > 20){
                        	JOptionPane.showMessageDialog(geometrie,
                            "Das eingegebene Ma ist auerhalb"+
                            "\ndes sinnvollen Bereichts!"+
                            "\nDer Wert wird zurckgesetz."+
                            "\n\nDer Bereich liegt zwischen 3m und 20m",
                            "Falscher Wert", JOptionPane.ERROR_MESSAGE);
                            wert = ((Double)ev.getOldValue()).doubleValue();
                            laengen.setHStielRechts(wert);
                         }
						//berprfung der Winkelkonsistenz
                        double winkel = (laengen.getHStielLinks()-
                                         laengen.getHStielRechts()) /
                                        laengen.getBreite();
                        if(Math.abs(winkel) > 0.466){//tan(25)=0,466
							double gk  = 0.460*laengen.getBreite();
                            if(winkel <= 0.0)
                                laengen.setHStielLinks(laengen.getHStielRechts()-gk);
                            else
                                laengen.setHStielLinks(laengen.getHStielRechts()+gk);
                        	JOptionPane.showMessageDialog(geometrie,
                            "Durch die eingegebene Gre, wrde die "+
                            "\nmaximale Dachneigung von 25 berschreiten!"+
                            "\nDer linke Stiel wird angepat.",
                            "Zu groe Dachneigung", JOptionPane.ERROR_MESSAGE);
						}
                        rahmenGeom.setH_stielRechts(wert);
					}
                    if(prop.equals("abstand")){
                        double wert = ((Double)ev.getNewValue()).doubleValue();
						//berprfung der Lngenkonsistenz
                    	if(wert < 1 || wert > 20){
                        	JOptionPane.showMessageDialog(geometrie,
                            "Das eingegebene Ma ist auerhalb"+
                            "\ndes sinnvollen Bereichts!"+
                            "\nDer Wert wird zurckgesetz."+
                            "\n\nDer Bereich liegt zwischen 1m und 20m",
                            "Falscher Wert", JOptionPane.ERROR_MESSAGE);
                            wert = ((Double)ev.getOldValue()).doubleValue();
                            laengen.setAbstand(wert);
                         }
					}
                    updateModel();
                 }});
		rahmenGeom.setH_keller(3.4);
        rahmenGeom.setH_stielLinks(9.7);
        rahmenGeom.setB_riegel(24.1);
        rahmenGeom.setH_stielRechts(8.9);

        //Stahlvektoren laden
        Vector prof = bautabellen.IProfile.getNamen();
		matLinks.getStahl().setNamen(prof);
        matRechts.getStahl().setNamen(prof);
        matRechts.getStahl().setProfil("HEB 600");
        matOben.getStahl().setNamen(prof);
        matOben.getStahl().setProfil("HEB 800");

		//Betonpanele fllen
        matLinks.getBeton().setBeton("C35/45");
        matLinks.getBeton().setB(0.5);
        matLinks.getBeton().setD(0.05);
        matLinks.getBeton().setH(0.75);
        matOben.getBeton().setBeton("C35/45");
        matOben.getBeton().setB(0.5);
        matOben.getBeton().setD(0.05);
        matOben.getBeton().setH(0.75);
        matRechts.getBeton().setBeton("C35/45");
        matRechts.getBeton().setB(0.5);
        matRechts.getBeton().setD(0.05);
        matRechts.getBeton().setH(0.75);

		//Defaultwerte eintragen
		matOben.getMaterial().setBeton(false);
        matRechts.getMaterial().setBeton(false);

        //Material verdrahten
        matLinks.getMaterial().addPropertyChangeListener(
            new PropertyChangeListener(){
				public void propertyChange(PropertyChangeEvent ev){
                    if(ev.getPropertyName().equals("beton")){
                        boolean beton = ((Boolean)ev.getNewValue()).booleanValue();
                        if(beton && !eckeLinks.isGelenk()){
                            try{
	                            eckeLinks.setGelenk(true);
			                }catch(PropertyVetoException pve){}
                            rahmenGeom.setGelLinks(true);
                        	JOptionPane.showMessageDialog(geometrie,
                            "Es knnen nur Stahlteile "+
                            "\nbiegesteif angeschlossen werden!" ,
                            "Option nicht untersttzt", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                updateModel();
                }
        });
        matOben.getMaterial().addPropertyChangeListener(
            new PropertyChangeListener(){
				public void propertyChange(PropertyChangeEvent ev){
                    if(ev.getPropertyName().equals("beton")){
                        boolean beton = ((Boolean)ev.getNewValue()).booleanValue();
                        if(beton && (!eckeLinks.isGelenk() || !eckeRechts.isGelenk())){
                            try{
            	                eckeLinks.setGelenk(true);
                                eckeRechts.setGelenk(true);
			                }catch(PropertyVetoException pve){}
                		    rahmenGeom.setGelLinks(true);
                            rahmenGeom.setGelRechts(true);
                        	JOptionPane.showMessageDialog(geometrie,
                            "Es knnen nur Stahlteile "+
                            "\nbiegesteif angeschlossen werden!" ,
                            "Option nicht untersttzt", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                updateModel();
                }
        });
        matRechts.getMaterial().addPropertyChangeListener(
            new PropertyChangeListener(){
				public void propertyChange(PropertyChangeEvent ev){
                    if(ev.getPropertyName().equals("beton")){
                        boolean beton = ((Boolean)ev.getNewValue()).booleanValue();
                        if(beton && !eckeRechts.isGelenk()){
							try{
                            	eckeRechts.setGelenk(true);
					        }catch(PropertyVetoException pve){}
                            rahmenGeom.setGelRechts(true);
                        	JOptionPane.showMessageDialog(geometrie,
                            "Es knnen nur Stahlteile "+
                            "\nbiegesteif angeschlossen werden!" ,
                            "Option nicht untersttzt", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                updateModel();
                }
        });



    }
	/**
     * Hier wird das Panel fr die Lasten konfiguriert
     */
    private void makeLasten(){
		//Modell updaten
        updateModel();
        //Panel erzeugen
        lasten = new JPanelLast();
        //Rahmen einstellen
        rahmenLast = lasten.getRahmen();
        rahmenLast.setH_keller(laengen.getHKeller());
        rahmenLast.setH_stielLinks(laengen.getHStielLinks());
        rahmenLast.setH_stielRechts(laengen.getHStielRechts());
        rahmenLast.setB_riegel(laengen.getBreite());
		rahmenLast.setGelLinks(eckeLinks.isGelenk());
		rahmenLast.setGelRechts(eckeRechts.isGelenk());

        //Eigenlast im Riegel
        lastRiegel = lasten.getRiegel();
		lastRiegel.setAufbauten(0.0010625);
        lastRiegel.addPropertyChangeListener(new PropertyChangeListener(){
			public void propertyChange(PropertyChangeEvent ev){
                    updateModel();
            }});
        //Eigenlast im linken Stiel
        lastStielLinks = lasten.getStielLinks();
		lastStielLinks.setAufbauten(0.0015);
        lastStielLinks.addPropertyChangeListener(new PropertyChangeListener(){
			public void propertyChange(PropertyChangeEvent ev){
                    updateModel();
            }});
        //Eigenlast im rechten Stiel
        lastStielRechts = lasten.getStielRechts();
		lastStielRechts.setAufbauten(0.0015);
        lastStielRechts.addPropertyChangeListener(new PropertyChangeListener(){
			public void propertyChange(PropertyChangeEvent ev){
                    updateModel();
            }});

        //Erddruck
        lastStielLinks.setReibungswinkel(30);
        lastStielLinks.setErdEigenlast(19.0/1000);
        lastStielLinks.setPersonenlast(7.5/1000);

        //Schneelast
        schnee = lasten.getSchnee();
        schnee.setGelHoehe(150);
        schnee.addPropertyChangeListener(new PropertyChangeListener(){
			public void propertyChange(PropertyChangeEvent ev){
                    updateModel();
            }});

    }

    /**
     * Hier wird die Rahmenfactory gepflegt und konfiguriert
     */
    private void makeRahmenModel(){
        factory = RahmenFactory.getFactory();
		factory.setGeometrie("Typ III", 9.7 , 8.9 , 24.1 , 3.4 , 6.4);
        factory.setStielLinks(0.02133333 , 18000 );
        factory.setKeller(0.02133333 , 18000 );
        factory.setRiegel(bautabellen.IProfile.getI_y("HEB 800")/100000000 , 210000);
        factory.setStielRechts(bautabellen.IProfile.getI_y("HEB 600")/100000000 , 210000);
        factory.setEigengewicht(0,0,0);
        factory.setErddruck(30,0.0019,0.0075);
        factory.setSchneeLast("I",100);
		rahmenModel =  factory.getRahmen();

    }

    /**
     * Hier werden die Schnittlasten erzeugt
     */
    private void makeSchnitt(){
		updateSchnitt();
    }

    /**
     * Hier werden die Schnittlasten erneuert und die Bemessung
     * durchgefhrt
     */
    private void updateSchnitt(){
		jTabbedPaneSchnitt.removeAll();
		factory.actionPerformed(new ActionEvent(this, 1,"auf geht's buam"));
        rahmenModel = factory.getRahmen();
		keller = rahmenModel.getKeller();
        linkerStiel = rahmenModel.getLinkerStiel();
        riegel = rahmenModel.getRiegel();
        rechterStiel = rahmenModel.getRechterStiel();
        double abmessungen[] = {laengen.getHKeller(),
                                laengen.getHStielLinks(),
                                laengen.getBreite(),
                                laengen.getHStielRechts()};
        boolean geleke[] = {eckeLinks.isGelenk(),eckeRechts.isGelenk()};
		//Gk neu erzeugen
        double mMax[] = new double[5];
        double qMax[] = new double[10];
        double nMax[] = new double[4];
        double yMax[] = new double[4];
        for(int i = 0 ; i < 6 ; i++){
			double m[] = {keller.getM22()[i],
						  linkerStiel.getM33()[i],
						  riegel.getM34()[i],
						  riegel.getM44()[i],
						  rechterStiel.getM45()[i]};
            for(int j = 0 ; j < 5 ; j++)
            	mMax[j] = Math.abs(mMax[j]) > Math.abs(m[j]) ? mMax[j] : m[j];

			double q[] = {keller.getQ11()[i],
						  keller.getQ22u()[i],
						  linkerStiel.getQ22o()[i],
						  linkerStiel.getQ238m()[i],
						  linkerStiel.getQ33u()[i],
						  riegel.getQ33o()[i],
						  riegel.getQ44o()[i],
						  rechterStiel.getQ44u()[i],
						  rechterStiel.getQ458m()[i],
						  rechterStiel.getQ55()[i]};
            for(int j = 0 ; j < 10 ; j++)
            	qMax[j] = Math.abs(qMax[j]) > Math.abs(q[j]) ? qMax[j] : q[j];

			double n[] = {keller.getN12()[i],
						  riegel.getN34()[i],
						  riegel.getN43()[i],
						  rechterStiel.getN45()[i]};
            for(int j = 0 ; j < 4 ; j++)
            	nMax[j] = Math.abs(nMax[j]) > Math.abs(n[j]) ? nMax[j] : n[j];

			double y[] = {rahmenModel.getY1()[i],
						  rahmenModel.getY2()[i],
						  rahmenModel.getY3()[i],
						  rahmenModel.getY4()[i]};
            for(int j = 0 ; j < 4 ; j++)
            	yMax[j] = Math.abs(yMax[j]) > Math.abs(y[j]) ? yMax[j] : y[j];

			gk[i] = new JPanelSchnitt(abmessungen, geleke, m, q, n, y);
        }
		gk[6] = new JPanelSchnitt(abmessungen, geleke, mMax, qMax, nMax, yMax);
        scGk[0] = new JScrollPane(gk[0]);
        scGk[1] = new JScrollPane(gk[1]);
        scGk[2] = new JScrollPane(gk[2]);
        scGk[3] = new JScrollPane(gk[3]);
        scGk[4] = new JScrollPane(gk[4]);
        scGk[5] = new JScrollPane(gk[5]);
        scGk[6] = new JScrollPane(gk[6]);
        jTabbedPaneSchnitt.add(scGk[0] , "GK Ia");
        jTabbedPaneSchnitt.add(scGk[1] , "GK Ib");
        jTabbedPaneSchnitt.add(scGk[2] , "GK Ic");
        jTabbedPaneSchnitt.add(scGk[3] , "GK Id");
        jTabbedPaneSchnitt.add(scGk[4] , "GK IIa");
        jTabbedPaneSchnitt.add(scGk[5] , "GK IIb");
        jTabbedPaneSchnitt.add(scGk[6] , "berlagerung");


        //Bemessung der Bauteweile
		bemessung.betontraeger.BalkenBean betonBemBalk =
            new bemessung.betontraeger.BalkenBean();
		bemessung.betontraeger.StuetzenBean betonBemStuet =
            new bemessung.betontraeger.StuetzenBean();
		bemessung.stahltraeger.BalkenBean stahlBem =
            new bemessung.stahltraeger.BalkenBean();

        /**
         * Linker Stiel und Keller
         */
        jPanelBemessungLinks.setBauteil("Linker Stiel mit Keller");
        //Beton
		if(matLinks.getMaterial().isBeton()){
        	betonBemStuet.setGammaC(1.5);
			betonBemStuet.setGammaS(1.15);
			betonBemStuet.setFyk(500);
			betonBemStuet.setM(Math.max(Math.abs(mMax[0]),Math.abs(mMax[1])));
			betonBemStuet.setN(nMax[0]);
            betonBemStuet.setQ(Math.abs(qMax[0]));
			for(int i = 1; i < 5; i++)
				if(Math.abs(qMax[i-1])<Math.abs(qMax[i]))
					betonBemStuet.setQ(Math.abs(qMax[i]));
			betonBemStuet.setL(laengen.getHKeller()+laengen.getHStielLinks());
			betonBemStuet.setH(matLinks.getBeton().getH());
			betonBemStuet.setD1(matLinks.getBeton().getD());
			betonBemStuet.setB(matLinks.getBeton().getB());
			betonBemStuet.setBeton(matLinks.getBeton().getBeton());
			betonBemStuet.setKnick(false);
            betonBemStuet.actionPerformed(new ActionEvent(this,1,"linker Stiel"));

			jPanelBemessungLinks.setBeton(true);
			jPanelBemessungLinks.setBalken(false);
			jPanelBemessungLinks.setBiegeKnickNachweis(-1);
            jPanelBemessungLinks.setZugBewehrung(betonBemStuet.getAz()*10000);
            jPanelBemessungLinks.setSchubBewehrung(betonBemStuet.getAq()*10000);
		}
        //Stahl
		if(!matLinks.getMaterial().isBeton()){
            String prof = matLinks.getStahl().getProfil();
			stahlBem.setN(nMax[0]);
			stahlBem.setM(Math.max(Math.abs(mMax[0]),Math.abs(mMax[1])));
            stahlBem.setQ(Math.abs(qMax[0]));
			for(int i = 1; i < 5; i++)
				if(Math.abs(qMax[i-1])<Math.abs(qMax[i]))
					stahlBem.setQ(Math.abs(qMax[i]));
			stahlBem.setL(laengen.getHKeller()+laengen.getHStielLinks());
			stahlBem.setA(bautabellen.IProfile.getA(prof));
			stahlBem.setB(bautabellen.IProfile.getB(prof));
			stahlBem.setH(bautabellen.IProfile.getH(prof));
			stahlBem.setT(bautabellen.IProfile.getT_f(prof));
			stahlBem.setR(bautabellen.IProfile.getR(prof));
			stahlBem.setS(bautabellen.IProfile.getT_w(prof));
			stahlBem.setB_t_vorhanden(bautabellen.IProfile.getD_pro_t_w(prof));
			stahlBem.setIz(bautabellen.IProfile.getI_z(prof));
			stahlBem.setIy(bautabellen.IProfile.getI_y(prof));
			stahlBem.setWply(bautabellen.IProfile.getW_ply(prof));
			stahlBem.setIyRad(bautabellen.IProfile.getIkl_y(prof));
			stahlBem.setE(210000);
			stahlBem.setFyk(240);
			stahlBem.setKsl_yy(bautabellen.IProfile.getKsl_yy(prof));
			stahlBem.setKsl_zz(bautabellen.IProfile.getKsl_zz(prof));
			stahlBem.setGammaM(1.1);
			stahlBem.setBiegeTest(false);
			stahlBem.setDrillTest(true);
			stahlBem.actionPerformed(new ActionEvent(this , 1 , "linker Stiel"));

			jPanelBemessungLinks.setBeton(false);
			jPanelBemessungLinks.setProfilName(prof);
			jPanelBemessungLinks.setBalken(false);
			jPanelBemessungLinks.setSpannungsNachweis(stahlBem.getSpannungsNachweis());
			jPanelBemessungLinks.setBiegeKnickNachweis(-1);
			jPanelBemessungLinks.setDrillKnickNachweis(Math.abs(stahlBem.getDrillNachweis()));
        }

        /**
         * Riegel
         */
        jPanelBemessungOben.setBauteil("Riegel");
        //Beton
		if(matOben.getMaterial().isBeton()){
        	betonBemBalk.setGammaC(1.5);
			betonBemBalk.setGammaS(1.15);
			betonBemBalk.setFyk(500);
			betonBemBalk.setM(mMax[1]);
			for(int i = 2; i < 4; i++)
				if(Math.abs(mMax[i-1])<Math.abs(mMax[i]))
					betonBemBalk.setM(mMax[i]);
			betonBemBalk.setN(Math.min(nMax[1], nMax[2]));
            betonBemBalk.setQ(Math.max(Math.abs(qMax[5]), Math.abs(qMax[6])));
			betonBemBalk.setL(laengen.getBreite());
			betonBemBalk.setH(matOben.getBeton().getH());
			betonBemBalk.setD1(matOben.getBeton().getD());
			betonBemBalk.setB(matOben.getBeton().getB());
			betonBemBalk.setBeton(matOben.getBeton().getBeton());

			betonBemBalk.setKnick(eckeLinks.isGelenk()&&eckeRechts.isGelenk());
            betonBemBalk.actionPerformed(new ActionEvent(this,1,"Riegel"));

			jPanelBemessungOben.setBeton(true);
			jPanelBemessungOben.setBalken(true);
            jPanelBemessungOben.setZugBewehrung(betonBemBalk.getAz()*10000);
            jPanelBemessungOben.setSchubBewehrung(betonBemBalk.getAq()*10000);
		}
        //Stahl
		if(!matOben.getMaterial().isBeton()){
            String prof = matOben.getStahl().getProfil();
			stahlBem.setN(Math.min(nMax[1], nMax[2]));
			stahlBem.setM(mMax[1]);
			for(int i = 2; i < 4; i++)
				if(Math.abs(mMax[i-1])<Math.abs(mMax[i]))
					stahlBem.setM(mMax[i]);
			stahlBem.setQ(Math.max(Math.abs(qMax[5]), Math.abs(qMax[6])));
			stahlBem.setL(laengen.getBreite());
			stahlBem.setA(bautabellen.IProfile.getA(prof));
			stahlBem.setB(bautabellen.IProfile.getB(prof));
			stahlBem.setH(bautabellen.IProfile.getH(prof));
			stahlBem.setT(bautabellen.IProfile.getT_f(prof));
			stahlBem.setR(bautabellen.IProfile.getR(prof));
			stahlBem.setS(bautabellen.IProfile.getT_w(prof));
			stahlBem.setB_t_vorhanden(bautabellen.IProfile.getD_pro_t_w(prof));
			stahlBem.setIz(bautabellen.IProfile.getI_z(prof));
			stahlBem.setIy(bautabellen.IProfile.getI_y(prof));
			stahlBem.setWply(bautabellen.IProfile.getW_ply(prof));
			stahlBem.setIyRad(bautabellen.IProfile.getIkl_y(prof));
			stahlBem.setE(210000);
			stahlBem.setFyk(240);
			stahlBem.setKsl_yy(bautabellen.IProfile.getKsl_yy(prof));
			stahlBem.setKsl_zz(bautabellen.IProfile.getKsl_zz(prof));
			stahlBem.setGammaM(1.1);
			stahlBem.setBiegeTest(eckeLinks.isGelenk()&&eckeRechts.isGelenk());
			stahlBem.setDrillTest(true);
			stahlBem.actionPerformed(new ActionEvent(this , 1 , "Riegel"));

			jPanelBemessungOben.setBeton(false);
			jPanelBemessungOben.setProfilName(prof);
			jPanelBemessungOben.setBalken(true);
			jPanelBemessungOben.setSpannungsNachweis(stahlBem.getSpannungsNachweis());
			jPanelBemessungOben.setBiegeKnickNachweis((eckeLinks.isGelenk()&&eckeRechts.isGelenk())?stahlBem.getBiegeNachweis() :-1);
			jPanelBemessungOben.setDrillKnickNachweis(stahlBem.getDrillNachweis());
        }
        /**
         * Rechter Stiel
         */
        jPanelBemessungRechts.setBauteil("Rechter Stiel");
        //Beton
		if(matRechts.getMaterial().isBeton()){
        	betonBemStuet.setGammaC(1.5);
			betonBemStuet.setGammaS(1.15);
			betonBemStuet.setFyk(500);
			betonBemStuet.setM(Math.max(Math.abs(mMax[3]),Math.abs(mMax[4])));
			betonBemStuet.setN(nMax[2]);
            betonBemStuet.setQ(Math.abs(qMax[7]));
			for(int i = 8; i < 10; i++)
				if(Math.abs(qMax[i-1])<Math.abs(qMax[i]))
					betonBemStuet.setQ(Math.abs(qMax[i]));
			betonBemStuet.setL(laengen.getHStielRechts());
			betonBemStuet.setH(matRechts.getBeton().getH());
			betonBemStuet.setD1(matRechts.getBeton().getD());
			betonBemStuet.setB(matRechts.getBeton().getB());
			betonBemStuet.setBeton(matRechts.getBeton().getBeton());
			betonBemStuet.setKnick(eckeRechts.isGelenk());
            betonBemStuet.actionPerformed(new ActionEvent(this,1,"rechter Stiel"));

			jPanelBemessungRechts.setBeton(true);
			jPanelBemessungRechts.setBalken(false);
            jPanelBemessungRechts.setZugBewehrung(betonBemStuet.getAz()*10000);
            jPanelBemessungRechts.setSchubBewehrung(betonBemStuet.getAq()*10000);
		}
        //Stahl
		if(!matRechts.getMaterial().isBeton()){
            String prof = matRechts.getStahl().getProfil();
			stahlBem.setM(Math.max(Math.abs(mMax[3]),Math.abs(mMax[4])));
			stahlBem.setN(nMax[2]);
            stahlBem.setQ(Math.abs(qMax[7]));
			for(int i = 8; i < 10; i++)
				if(Math.abs(qMax[i-1])<Math.abs(qMax[i]))
					betonBemStuet.setQ(Math.abs(qMax[i]));
			stahlBem.setL(laengen.getHStielRechts());
			stahlBem.setA(bautabellen.IProfile.getA(prof));
			stahlBem.setB(bautabellen.IProfile.getB(prof));
			stahlBem.setH(bautabellen.IProfile.getH(prof));
			stahlBem.setT(bautabellen.IProfile.getT_f(prof));
			stahlBem.setR(bautabellen.IProfile.getR(prof));
			stahlBem.setS(bautabellen.IProfile.getT_w(prof));
			stahlBem.setB_t_vorhanden(bautabellen.IProfile.getD_pro_t_w(prof));
			stahlBem.setIz(bautabellen.IProfile.getI_z(prof));
			stahlBem.setIy(bautabellen.IProfile.getI_y(prof));
			stahlBem.setWply(bautabellen.IProfile.getW_ply(prof));
			stahlBem.setIyRad(bautabellen.IProfile.getIkl_y(prof));
			stahlBem.setE(210000);
			stahlBem.setFyk(240);
			stahlBem.setKsl_yy(bautabellen.IProfile.getKsl_yy(prof));
			stahlBem.setKsl_zz(bautabellen.IProfile.getKsl_zz(prof));
			stahlBem.setGammaM(1.1);
			stahlBem.setBiegeTest(eckeRechts.isGelenk());
			stahlBem.setDrillTest(true);
			stahlBem.actionPerformed(new ActionEvent(this , 1 , "rechter Stiel"));

			jPanelBemessungRechts.setBeton(false);
			jPanelBemessungRechts.setProfilName(prof);
			jPanelBemessungRechts.setBalken(false);
			jPanelBemessungRechts.setSpannungsNachweis(stahlBem.getSpannungsNachweis());
			jPanelBemessungRechts.setBiegeKnickNachweis((eckeRechts.isGelenk())?stahlBem.getBiegeNachweis() :-1);
			jPanelBemessungRechts.setDrillKnickNachweis(Math.abs(stahlBem.getDrillNachweis()));
        }

        /*
         * Biegesteifenecken mit Daten versorgen
         */
        //linke Ecke
        if(eckeLinks.isGelenk())
			jPanelBiegeEcke.setVisibleLinks(false);
        if(!eckeLinks.isGelenk()){
            String riegelProf = matOben.getStahl().getProfil();
            String stielProf = matLinks.getStahl().getProfil();
            jPanelBiegeEcke.setVisibleLinks(true);
			jIFEckeDatenlinks = jPanelBiegeEcke.getLinks();
            jIFEckeDatenlinks.setN_riegel(nMax[1]);
            jIFEckeDatenlinks.setM_riegel(mMax[2]);
            jIFEckeDatenlinks.setQ_riegel(qMax[5]);
            jIFEckeDatenlinks.setNeigung((laengen.getHStielRechts()-laengen.getHStielLinks())/laengen.getBreite());
            jIFEckeDatenlinks.setH_riegel(bautabellen.IProfile.getH(riegelProf));
            jIFEckeDatenlinks.setH_stiel(bautabellen.IProfile.getH(stielProf));
			jIFEckeDatenlinks.setFlanschdicke(bautabellen.IProfile.getT_f(riegelProf));
            jIFEckeDatenlinks.setFlanschbreite(bautabellen.IProfile.getB(riegelProf));
            jIFEckeDatenlinks.setAnzSchrauben(4);
        }
        //rechte Ecke
        if(eckeRechts.isGelenk())
			jPanelBiegeEcke.setVisibleRechts(false);
        if(!eckeRechts.isGelenk()){
            jPanelBiegeEcke.setVisibleRechts(true);
            String riegelProf = matOben.getStahl().getProfil();
            String stielProf = matRechts.getStahl().getProfil();
			jIFEckeDatenrechts = jPanelBiegeEcke.getRechts();
            jIFEckeDatenrechts.setN_riegel(nMax[2]);
            jIFEckeDatenrechts.setM_riegel(mMax[3]);
            jIFEckeDatenrechts.setQ_riegel(qMax[6]);
            jIFEckeDatenrechts.setNeigung((laengen.getHStielLinks()-laengen.getHStielRechts())/laengen.getBreite());
            jIFEckeDatenrechts.setH_riegel(bautabellen.IProfile.getH(riegelProf));
            jIFEckeDatenrechts.setH_stiel(bautabellen.IProfile.getH(stielProf));
			jIFEckeDatenrechts.setFlanschdicke(bautabellen.IProfile.getT_f(riegelProf));
            jIFEckeDatenrechts.setFlanschbreite(bautabellen.IProfile.getB(riegelProf));
            jIFEckeDatenrechts.setAnzSchrauben(4);
        }

    }

    /**
     * Hier wird das Model gepflegt
     */
    public void updateModel(){
        double h_links = laengen.getHStielLinks();
        double h_rechs = laengen.getHStielRechts();
        double breite = laengen.getBreite();
        double h_keller = laengen.getHKeller();
        double abstand = laengen.getAbstand();
		//Testparameter
        boolean geometrieSet = false;
        boolean linkerStielSet = false;
        boolean kellerSet = false;
        boolean rechterSielSet = false;
        boolean riegelSet = false;
        boolean eigengewichtSet = false;
        boolean erddruckSet = false;
        boolean schneeSet = false;

		//Typ I
        if(!eckeLinks.isGelenk() && !eckeRechts.isGelenk())
            geometrieSet = factory.setGeometrie("Typ I", h_links, h_rechs, breite, h_keller, abstand);
		//Typ II
        if(!eckeLinks.isGelenk() && eckeRechts.isGelenk())
            geometrieSet = factory.setGeometrie("Typ II", h_links, h_rechs, breite, h_keller, abstand);
		//Typ III
        if(eckeLinks.isGelenk() && !eckeRechts.isGelenk())
            geometrieSet = factory.setGeometrie("Typ III", h_links, h_rechs, breite, h_keller, abstand);
		//Typ IV
        if(eckeLinks.isGelenk() && eckeRechts.isGelenk())
            geometrieSet = factory.setGeometrie("Typ IV", h_links, h_rechs, breite, h_keller, abstand);
        //Stiel links + Keller
        if(matLinks.getMaterial().isBeton()){
            double b = matLinks.getBeton().getB();
            double h = matLinks.getBeton().getH()+matLinks.getBeton().getD();
            linkerStielSet = factory.setStielLinks(b*h*h*h/12 , 18000);
            kellerSet = factory.setKeller(b*h*h*h/12 , 18000);
        }else{
            double i = bautabellen.IProfile.getI_y(matLinks.getStahl().getProfil())/100000000;
			linkerStielSet = factory.setStielLinks(i , 210000);
			kellerSet = factory.setKeller(i , 210000);
        }

        //Stiel rechts
        if(matRechts.getMaterial().isBeton()){
            double b = matRechts.getBeton().getB();
            double h = matRechts.getBeton().getH()+matRechts.getBeton().getD();
            rechterSielSet = factory.setStielRechts(b*h*h*h/12 , 18000);
        }else{
            double i = bautabellen.IProfile.getI_y(matRechts.getStahl().getProfil())/100000000;
			rechterSielSet = factory.setStielRechts(i , 210000);
        }

        //Riegel
        if(matOben.getMaterial().isBeton()){
            double b = matOben.getBeton().getB();
            double h = matOben.getBeton().getH()+matOben.getBeton().getD();
            riegelSet = factory.setRiegel(b*h*h*h/12 , 18000);
        }else{
            double i = bautabellen.IProfile.getI_y(matOben.getStahl().getProfil())/100000000;
			riegelSet = factory.setRiegel(i , 210000);
        }

        //Lastenpanel updaten
        if(lasten != null){
			rahmenLast.setH_keller(laengen.getHKeller());
			rahmenLast.setH_stielLinks(laengen.getHStielLinks());
			rahmenLast.setH_stielRechts(laengen.getHStielRechts());
			rahmenLast.setB_riegel(laengen.getBreite());
            rahmenLast.setGelLinks(eckeLinks.isGelenk());
            rahmenLast.setGelRechts(eckeRechts.isGelenk());

            //Eignegewicht im Riegel
            double eigl = matOben.getMaterial().isBeton() ?
                          matOben.getBeton().getB()*(matOben.getBeton().getH()+matOben.getBeton().getD())*25/1000 :
			    		  bautabellen.IProfile.getG_k(matOben.getStahl().getProfil())/1000;
			double wert = lastRiegel.getAufbauten();
            double g_riegel = eigl + wert*laengen.getAbstand();
            lastRiegel.setEigenlast(eigl);
            lastRiegel.setGewichtskraft(g_riegel*1.35);

            //Eignegewicht im linken Stiel
            eigl = matLinks.getMaterial().isBeton() ?
                          matLinks.getBeton().getB()*(matLinks.getBeton().getH()+matLinks.getBeton().getD())*25/1000 :
			    		  bautabellen.IProfile.getG_k(matLinks.getStahl().getProfil())/1000;
			wert = lastStielLinks.getAufbauten();
            double g_links = (eigl + wert*laengen.getAbstand())*
                               (laengen.getHKeller()+laengen.getHStielLinks());
            lastStielLinks.setEigenlast(eigl);
            lastStielLinks.setGewichtskraft(g_links*1.35);

            //Eignegewicht im rechten Stiel
            eigl = matRechts.getMaterial().isBeton() ?
                          matRechts.getBeton().getB()*(matRechts.getBeton().getH()+matRechts.getBeton().getD())*25/1000 :
			    		  bautabellen.IProfile.getG_k(matRechts.getStahl().getProfil())/1000;
			wert = lastStielRechts.getAufbauten();
            double g_rechts = (eigl + wert*laengen.getAbstand())*
                               laengen.getHStielRechts();
            lastStielRechts.setEigenlast(eigl);
            lastStielRechts.setGewichtskraft(g_rechts*1.35);

            eigengewichtSet = factory.setEigengewicht(g_links , g_riegel , g_rechts);

			//Windlasten
			Wind wind = new Wind();
			lastStielRechts.setWinddruck0_8(wind.getDruck0_8(laengen.getAbstand()));
			lastStielRechts.setWinddruck8_20(wind.getDruck8_20(laengen.getAbstand()));
			lastStielRechts.setWindsog0_8(wind.getSog0_8(laengen.getAbstand()));
			lastStielRechts.setWindsog8_20(wind.getSog8_20(laengen.getAbstand()));
			lastStielRechts.setWindsog(Math.max(laengen.getHStielRechts(), laengen.getHStielRechts()) <= 8 ?
				wind.getSogDach0_8(laengen.getAbstand()) :
				wind.getSogDach8_20(laengen.getAbstand()));

            //Erdlasten
			double phi = lastStielLinks.getReibungswinkel();
            double winkel =  Math.tan(Math.toRadians(45-phi/2))*Math.tan(Math.toRadians(45-phi/2));
			double gamma = lastStielLinks.getErdEigenlast();
			double p = lastStielLinks.getPersonenlast();
            lastStielLinks.setErddruck(gamma * winkel * laengen.getHKeller() *laengen.getHKeller()*1.5);
            lastStielLinks.setPersonendruck(p * winkel * laengen.getHKeller()*1.35);

            erddruckSet = factory.setErddruck((int)phi, gamma , p);

            //Schneelasten
            if(schnee != null){
            schnee.setSchneelast(0.75*laengen.getAbstand()/1000*1.5);
            schneeSet = factory.setSchneeLast(schnee.getSchneeLastZone() , (int)schnee.getGelHoehe());}

			updateSchnitt();

/*
            System.out.println("Geometrie = "+geometrieSet);
            System.out.println("linker Stiel = "+linkerStielSet);
            System.out.println("rechter Stiel = "+rechterSielSet);
            System.out.println("Keller = "+kellerSet);
            System.out.println("Riegle = "+riegelSet);
            System.out.println("Eingengewicht = "+eigengewichtSet);
            System.out.println("Erdlast = "+erddruckSet);
            System.out.println("Schnee = "+schneeSet);
*/

        }

    }


    /**
     * gettet fr die Geometrie
     */
    JPanelGeom getGeometrie(){
        return geometrie;
    }

    /**
     * gettet fr die Lasten
     */
    JPanelLast getLasten(){
        return lasten;
    }

    /**
     * getter fr die Schnitte
     */
    JTabbedPane getSchnitte(){
        return jTabbedPaneSchnitt;
    }

    /**
     * Biegesteife Ecke
     */
    JPanelBiegeEcke getBiegesteifeEcke(){
        jPanelBiegeEcke.setVisibleLinks(false);
        jPanelBiegeEcke.setVisibleRechts(false);
        return jPanelBiegeEcke;
    }

    /**
     * Getter fr die Bemessung
     */
    JPanel getBemessung(){
        jPanelBemessung.setLayout(new GridLayout(3,1));
        jPanelBemessung.add(jPanelBemessungLinks);
        jPanelBemessung.add(jPanelBemessungOben);
        jPanelBemessung.add(jPanelBemessungRechts);
        return jPanelBemessung;
    }

	static private RahmenFactory factory;
    static private Rahmen rahmenModel;
    static private Keller keller;
    static private LinkerStiel linkerStiel;
    static private Riegel riegel;
    static private RechterStiel rechterStiel;

    static private GUIControl control;

    //Komponeneten fr Geometrie
    private JPanelGeom geometrie;
    private JPanelGeomEcken eckeLinks;
    private JPanelGeomEcken eckeRechts;
    private JPanelGeomMatTop matLinks;
    private JPanelGeomMatTop matRechts;
    private JPanelGeomMatTop matOben;
    private JPanelGeomLaengen laengen;
    private JPanelGeomRahmen rahmenGeom;

    //Komponenten fr Lasten
    private JPanelLast lasten;
    private JPanelLastStielLinks  lastStielLinks;
	private JPanelLastStielRechts lastStielRechts;
    private JPanelLastRiegel lastRiegel;
    private JPanelLastRahmen rahmenLast;
    private JPanelLastSchnee schnee;

    //Komponenten fr Schnittgren
    private JTabbedPane jTabbedPaneSchnitt = new JTabbedPane();
	private JPanelSchnitt gk[] = new JPanelSchnitt[7];
	private JScrollPane scGk[] = new JScrollPane[7];

    //Komponeneten fr die Bemessung
    private JPanel jPanelBemessung = new JPanel();
    private JPanelBemessung jPanelBemessungLinks = new JPanelBemessung();
    private JPanelBemessung jPanelBemessungOben = new JPanelBemessung();
    private JPanelBemessung jPanelBemessungRechts = new JPanelBemessung();

    //Komponeneten fr die biegesteife Ecke
    private JPanelBiegeEcke jPanelBiegeEcke = new JPanelBiegeEcke();
    private JInternalFrameEckeDaten jIFEckeDatenlinks;
    private JInternalFrameEckeDaten jIFEckeDatenrechts;






}
