/* Generated by Together */

package gui;

import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;
import java.awt.Dimension;
import java.awt.BasicStroke;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.image.BufferedImage;
import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

/**
 * Fr die eingabe der Geometrie ist dieses Panel die Ilustration
 * @author Johannes Hhne
 * geprft und fr gut befunden
 */
final class JPanelGeomRahmen extends JPanel {
    JPanelGeomRahmen(){
        initGUI();
    }

    /** This method is called from within the constructor to
     * initialize the form. */
    private void initGUI() {
        setBorder(javax.swing.BorderFactory.createEtchedBorder());
        this.setPreferredSize(new Dimension(500,300));
		this.repaint();
    }

    /**
     * paint berschreiben
     */
    public void paint(Graphics g){
		//Allgemeinen Parameter
        super.paint(g);
		Graphics2D g1 = (Graphics2D)g;
		scale();
        int l = this.getWidth();
		int h = this.getHeight();

		BufferedImage image = new BufferedImage(l,h,BufferedImage.TYPE_INT_RGB);
        Graphics2D g2 = image.createGraphics();
        g2.setBackground(getBackground());
        g2.setColor(getForeground());
		g2.clearRect(0,0,l,h);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING , RenderingHints.VALUE_ANTIALIAS_ON);


		//Rahmen selbst
        GeneralPath p = new GeneralPath();
        p.moveTo((float)0.1*l ,
                 (float)0.9*h);
        p.lineTo((float)0.1*l ,
                 (float)0.9*h - (getH_keller()+getH_stielLinks())*scale);
        p.lineTo((float)0.1*l + getB_riegel()*scale ,
                 (float)0.9*h - (getH_keller() + getH_stielRechts())*scale);
        p.lineTo((float)0.1*l + getB_riegel()*scale ,
                  (float)0.9*h -getH_keller()*scale );

        g2.setStroke(new BasicStroke((int)(scale*0.2)));
        g2.draw(p);


        //Lager
        setLagerMom((int)(0.1*l),(int)(0.9*h), g2);
        setLagerMom((float)(0.1*l + getB_riegel()*scale) ,
                    (float)(0.9*h -getH_keller()*scale) , g2);

        setLagerGleit((float)(0.1*l) , (float)(0.9*h - getH_keller()*scale), g2);

        //Momentengelenke
        if(gelLinks)
            setMomGel((float)0.1*l ,
                        (float)(0.9*h-(getH_keller()+getH_stielLinks())*scale), g2);
        if(gelRechts)
            setMomGel((float)(0.1*l + getB_riegel()*scale) ,
                        (float)(0.9*h-(getH_keller()+getH_stielRechts())*scale), g2);

        //Bezugslinien
        float lin = ((BasicStroke)g2.getStroke()).getLineWidth() > 5 ?
                    2*((BasicStroke)g2.getStroke()).getLineWidth() : 5;
        GeneralPath be = new GeneralPath();
        be.moveTo((float)0.1*l+lin ,
                 (float)0.9*h);
        be.lineTo((float)0.1*l+lin ,
                 (float)0.9*h - (getH_keller()+getH_stielLinks())*scale + lin);
        be.lineTo((float)0.1*l + getB_riegel()*scale - lin ,
                 (float)0.9*h - (getH_keller() + getH_stielRechts())*scale + lin);
        be.lineTo((float)0.1*l + getB_riegel()*scale - lin ,
                  (float)0.9*h -getH_keller()*scale );

        float[] dash = { 2*lin , lin };
        g2.setStroke(new BasicStroke(lin/4 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER , 1 , dash , 0));
        g2.draw(be);


		//Beschriftung
		/**
         * Die Gre der Schrift wird so bestimmt, dass sie so gro
         * wie der Keller ist
         */
        int i = 12;
        int wortLaenge = 0;
		while(wortLaenge < getH_keller()*scale && i < 25){
        	g2.setFont(new Font("Serif" , Font.PLAIN, i));
            wortLaenge =((FontMetrics)g2.getFontMetrics()).stringWidth("h Keller");
            i++;
		}

        //breite
        wortLaenge =(int)((FontMetrics)g2.getFontMetrics()).stringWidth("breite");
        g2.drawString("breite" ,
                      (float)(0.1*l +  getB_riegel()*scale*0.5 - wortLaenge*0.5) ,
                      (float)(0.9*h-getH_keller()*scale/2)-lin);
        g2.setStroke(new BasicStroke(lin/4 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER));
        g2.drawLine( (int)(0.1*l-2*lin),
                     (int)(0.9*h-getH_keller()*scale/2) ,
                     (int)(0.1*l+ getB_riegel()*scale+2*lin),
                     (int)(0.9*h-getH_keller()*scale/2));
        g2.drawLine( (int)(0.1*l+getB_riegel()*scale),
                     (int)(0.9*h-getH_keller()*scale/2+lin),
                     (int)(0.1*l+getB_riegel()*scale),
                     (int)(0.9*h-getH_keller()*scale/2-2*lin));
        g2.drawLine( (int)(0.1*l+getB_riegel()*scale-lin),
                     (int)(0.9*h-getH_keller()*scale/2+lin),
                     (int)(0.1*l+getB_riegel()*scale+lin),
                     (int)(0.9*h-getH_keller()*scale/2-lin));
        g2.drawLine( (int)(0.1*l-lin),
                     (int)(0.9*h-getH_keller()*scale/2+lin),
                     (int)(0.1*l+lin),
                     (int)(0.9*h-getH_keller()*scale/2-lin));

        //hhe Keller
        wortLaenge =(int)((FontMetrics)g2.getFontMetrics()).stringWidth("h Keller");
		float x = (float)(0.1*l-2*lin);
        float y = (float)(0.9*h);
		AffineTransform rot  = new AffineTransform();
        rot.rotate(-Math.PI/2,(double)x,(double)y);
        g2.setTransform(rot);
        g2.drawString("h Keller" , x, y);

        //hhe linker Stiel
        wortLaenge =(int)((FontMetrics)g2.getFontMetrics()).stringWidth("h linker Stiel");
		x = (float)(x+getH_keller()*scale+getH_stielLinks()*scale*0.5 - wortLaenge*0.5);
        y = (float)y;
        g2.drawString("h linker Stiel" , x, y);

        //hhe rechter Stiel
        wortLaenge =(int)((FontMetrics)g2.getFontMetrics()).stringWidth("h rechter Stiel");
        x =  (float)(getB_riegel()*scale + 0.1*l - 2*lin);
		y =  (float)(0.9*h- getH_keller()*scale  - getH_stielRechts()*scale*0.5 + wortLaenge*0.5);
		rot.setToIdentity();
        rot.rotate(-1.570796327,(double)x,(double)y);
        g2.setTransform(rot);
        g2.drawString("h rechter Stiel" , x, y);

        g1.drawImage(image,0,0,null);

    }

    /**
     * Hier wird der Rahmen Skaliert, um ihn in die gegebene Abmessung des
     * Rahmens proportiondgetreu einzufgen
     */
    private void scale(){
		double l = this.getWidth()*0.8;
        double h = this.getHeight()*0.8;

        double scale_l = l/this.getB_riegel();
        double scale_h = h/(this.getH_keller() +
                       Math.max(this.getH_stielLinks() , this.getH_stielRechts()));

        scale = (float)Math.min(scale_l , scale_h);
    }

    /**
     * Zeichnet die Momentenlaget
     */
	private void setLagerMom(float xo, float yo, Graphics2D g2){
		int r = (int)(getB_riegel()*scale*0.04);
		int x = (int)xo-r/2;
        int y = (int)yo;
        g2.drawArc(x,y,r,r,0,360);
        g2.drawLine(x  , (int)(yo+r/2)  ,  x-r  , (int)(yo+r/2));
        g2.drawLine(x+r  ,  (int)(yo+r/2)  ,  x+2*r  ,  (int)(yo+r/2));
	}

    /**
     * Zeichnet die Gleitlager
     */
	private void setLagerGleit(float xo, float yo, Graphics2D g2){
		float r = (float)(getB_riegel()*scale*0.02);
        float lin =((BasicStroke)g2.getStroke()).getLineWidth();
        float x = xo+lin;
        float y = yo;
        GeneralPath dr = new GeneralPath();
		dr.moveTo(x,y);
        dr.lineTo(x+2*r,y+r);
        dr.lineTo(x+2*r,y-r);
        dr.closePath();
        dr.moveTo(x+2*r+2*lin,y+r);
        dr.lineTo(x+2*r+2*lin,y-r);
        g2.draw(dr);
	}

    /**
     * Momentengelenke in den Ecken
     */
    private void setMomGel(float xo, float yo, Graphics2D g2){
		int r = (int)(getB_riegel()*scale*0.04);
		int x = (int)xo-r/2;
        int y = (int)yo-r/2;
        Color linie = g2.getColor();
		g2.setColor(g2.getBackground());
        g2.fillArc(x,y,r,r,0,360);
        g2.setColor(linie);
        g2.drawArc(x,y,r,r,0,360);
    }

    /**
     * Hhe des Kellers in [m]
     */
    private double h_keller = 0.0;
    /**
     * Setzt die Hhe des Kellers in [m]
     * @param h_keller - Hhe des Kellers in [m]
     */
    void setH_keller(double h_keller){
        this.h_keller = h_keller;
    	repaint();
    }
    /**
     * Liefert die Hhe des Kellers in [m]
     * @return Hhe des Kellers in [m]
     */
    float getH_keller(){return (float)h_keller;}

    /**
     * Hhe des linken Stiels in [m]
     */
    private double h_stielLinks = 0.0;
    /**
     * Setzt die Hhe des linken Stiels in [m]
     * @param h_stielLinks - Hhe des linken Stiels in [m]
     */
    void setH_stielLinks(double h_stielLinks){
        this.h_stielLinks = h_stielLinks;
        repaint();
    }
    /**
     * Liefert die Hhe des linken Stiels in [m]
     * @return Hhe des linken Stiels in [m]
     */
    float getH_stielLinks(){return (float)h_stielLinks;}

    /**
     * Hhe des rechten Stiels in [m]
     */
    private double h_stielRechts = 0.0;
    /**
     * Setzt die Hhe des rechten Stiels in [m]
     * @param h_stielRechts - Hhe des rechten Stiels in [m]
     */
    void setH_stielRechts(double h_stielRechts){
        this.h_stielRechts = h_stielRechts;
        repaint();
    }
    /**
     * Liefert die Hhe des rechten Stiels in [m]
     * @return Hhe des rechten Stiels in [m]
     */
    float getH_stielRechts(){return (float)h_stielRechts;}

    /**
     * Breite des Riegels in [m]
     */
    private double b_riegel = 0.0;
    /**
     * Setzt die Breite des Riegels in [m]
     * @param b_riegel - Breite des Riegels in [m]
     */
    void setB_riegel(double b_riegel){
        this.b_riegel = b_riegel;
        repaint();}
    /**
     * Liefert die Breite des Riegels in [m]
     * @return Breite des Riegels in [m]
     */
    float getB_riegel(){return (float)b_riegel;}

    /**
     * Momentengelenk links oben
     */
    private boolean gelLinks = true;
    /**
     * Setzt Momentengelenk links oben
     * @param gelLinks - Momentengelenk links oben
     */
    void setGelLinks(boolean gelLinks){
        this.gelLinks = gelLinks;
        repaint();
    }
    /**
     * Liefert Momentengelenk links oben
     * @return Momentengelenk links oben
     */
    boolean getGelLinks(){return gelLinks;}

    /**
     * Momentengelenk rechts oben
     */
    private boolean gelRechts = true;
    /**
     * Setzt Momentengelenk rechts oben
     * @param gelRechts - Momentengelenk rechts oben
     */
    void setGelRechts(boolean gelRechts){
        this.gelRechts = gelRechts;
        repaint();
    }
    /**
     * Liefert Momentengelenk rechts oben
     * @return Momentengelenk rechts oben
     */
    boolean getGelRechts(){return gelRechts;}


    /**
     * Der Skalierungsfaktor
     */
    private float scale = 1;
}
