/* Generated by Together */

package gui;

import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.GeneralPath;
import java.awt.geom.AffineTransform;
import java.awt.Dimension;
import java.awt.BasicStroke;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.image.BufferedImage;
import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.Point;

/**
 * Fr die eingabe der Lasten ist dieses Panel die Ilustration
 * @author Johannes Hhne
 */
class JPanelLastRahmen extends JPanel {
    JPanelLastRahmen(){
        initGUI();
    }

    /** This method is called from within the constructor to
     * initialize the form. */
    private void initGUI() {
        setBorder(javax.swing.BorderFactory.createEtchedBorder());
        this.setPreferredSize(new Dimension(500,300));
		this.repaint();
    }

    /**
     * paint berschreiben
     */
    public void paint(Graphics g){
		//Allgemeinen Parameter
        super.paint(g);
		Graphics2D g1 = (Graphics2D)g;
		scale();
        l = this.getWidth();
		h = this.getHeight();

		BufferedImage image = new BufferedImage(l,h,BufferedImage.TYPE_INT_RGB);
        Graphics2D g2 = image.createGraphics();
        g2.setBackground(getBackground());
        g2.setColor(getForeground());
		g2.clearRect(0,0,l,h);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING , RenderingHints.VALUE_ANTIALIAS_ON);


		//Rahmen selbst
        GeneralPath p = new GeneralPath();
        p.moveTo((float)fixPktx ,
                 (float)fixPkty);
        p.lineTo((float)fixPktx ,
                 (float)fixPkty - (getH_keller()+getH_stielLinks())*scale);
        p.lineTo((float)fixPktx + getB_riegel()*scale ,
                 (float)fixPkty - (getH_keller() + getH_stielRechts())*scale);
        p.lineTo((float)fixPktx + getB_riegel()*scale ,
                  (float)fixPkty -getH_keller()*scale );

        g2.setStroke(new BasicStroke((int)(scale*0.2)));
        g2.draw(p);


        //Lager
        setLagerMom((int)(fixPktx),(int)(fixPkty), g2);
        setLagerMom((float)(fixPktx + getB_riegel()*scale) ,
                    (float)(fixPkty -getH_keller()*scale) , g2);

        setLagerGleit((float)(fixPktx) , (float)(fixPkty - getH_keller()*scale), g2);

        //Momentengelenke
        if(gelLinks)
            setMomGel((float)fixPktx ,
                        (float)(fixPkty-(getH_keller()+getH_stielLinks())*scale), g2);
        if(gelRechts)
            setMomGel((float)(fixPktx + getB_riegel()*scale) ,
                        (float)(fixPkty-(getH_keller()+getH_stielRechts())*scale), g2);

        //Bezugslinien
        lin = ((BasicStroke)g2.getStroke()).getLineWidth() > 5 ?
                    2*((BasicStroke)g2.getStroke()).getLineWidth() : 5;
        GeneralPath be = new GeneralPath();
        be.moveTo((float)fixPktx+lin ,
                 (float)fixPkty);
        be.lineTo((float)fixPktx+lin ,
                 (float)fixPkty - (getH_keller()+getH_stielLinks())*scale + lin);
        be.lineTo((float)fixPktx + getB_riegel()*scale - lin ,
                 (float)fixPkty - (getH_keller() + getH_stielRechts())*scale + lin);
        be.lineTo((float)fixPktx + getB_riegel()*scale - lin ,
                  (float)fixPkty -getH_keller()*scale );

        float[] dash = { 2*lin , lin };
        g2.setStroke(new BasicStroke(lin/4 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER , 1 , dash , 0));
        g2.draw(be);

		//Windlasten antragen
        setWind(g2);

        //erdlasten antragen
        setErdlast(g2);

        //Auflaste antragen
        setAuflasten(g2);

        g1.drawImage(image,0,0,null);

    }

    /**
     * Hier wird der Rahmen Skaliert, um ihn in die gegebene Abmessung des
     * Rahmens proportiondgetreu einzufgen
     */
    private void scale(){
		double l = this.getWidth()*0.6;
        double h = this.getHeight()*0.6;

        double scale_l = l/this.getB_riegel();
        double scale_h = h/(this.getH_keller() +
                       Math.max(this.getH_stielLinks() , this.getH_stielRechts()));

        scale = (float)Math.min(scale_l , scale_h);
        fixPktx = (float)(0.2*getWidth());
        fixPkty = (float)(0.95*getHeight());
    }

    /**
     * Zeichnet die Momentenlaget
     */
	private void setLagerMom(float xo, float yo, Graphics2D g2){
		int r = (int)(getB_riegel()*scale*0.04);
		int x = (int)xo-r/2;
        int y = (int)yo;
        g2.drawArc(x,y,r,r,0,360);
        g2.drawLine(x  , (int)(yo+r/2)  ,  x-r  , (int)(yo+r/2));
        g2.drawLine(x+r  ,  (int)(yo+r/2)  ,  x+2*r  ,  (int)(yo+r/2));
	}

    /**
     * Zeichnet die Gleitlager
     */
	private void setLagerGleit(float xo, float yo, Graphics2D g2){
		float r = (float)(getB_riegel()*scale*0.02);
        float lin =((BasicStroke)g2.getStroke()).getLineWidth();
        float x = xo+lin;
        float y = yo;
        GeneralPath dr = new GeneralPath();
		dr.moveTo(x,y);
        dr.lineTo(x+2*r,y+r);
        dr.lineTo(x+2*r,y-r);
        dr.closePath();
        dr.moveTo(x+2*r+2*lin,y+r);
        dr.lineTo(x+2*r+2*lin,y-r);
        g2.draw(dr);
	}

    /**
     * Momentengelenke in den Ecken
     */
    private void setMomGel(float xo, float yo, Graphics2D g2){
		int r = (int)(getB_riegel()*scale*0.04);
		int x = (int)xo-r/2;
        int y = (int)yo-r/2;
        Color linie = g2.getColor();
		g2.setColor(g2.getBackground());
        g2.fillArc(x,y,r,r,0,360);
        g2.setColor(linie);
        g2.drawArc(x,y,r,r,0,360);
    }

    /**
     * Pfeile fr die Lasten
     * @param p - Fupunkt des Pfeils
     *        l - Lnge des Pfeils in Pix
     *        w - Winkel des Pfeils 0    -  3 Uhr
     *                              PI/2 - 12 Uhr
     * 								PI   -  9 Uhr...
     * 		 g2 - Zeichenobjekt
     */
    private void setPfeil(Point p, float l, float w, Graphics2D g2){
		float sx = (float)p.getX();
        float sy = (float)p.getY();
        float zx = (float)(Math.cos(w)*l)+sx;
        float zy = (float)(Math.sin(w)*l)+sy;
        float ox = (float)(Math.cos(w-Math.PI/6)*(-0.2*l))+zx;
        float oy = (float)(Math.sin(w-Math.PI/6)*(-0.2*l))+zy;
        float ux = (float)(Math.cos(w+Math.PI/6)*(-0.2*l))+zx;
        float uy = (float)(Math.sin(w+Math.PI/6)*(-0.2*l))+zy;
        GeneralPath pfe = new GeneralPath();
        pfe.moveTo(sx, sy);
        pfe.lineTo(zx , zy);
        pfe.moveTo(ox, oy);
        pfe.lineTo(zx, zy);
        pfe.lineTo(ux , uy);
		g2.draw(pfe);
    }

    /**
     * Zeichnet die Windlasten
     */
    private void setWind(Graphics2D g2){
   		//Dickenskalierung
        g2.setStroke(new BasicStroke(lin/4));

        //Wind von rechts sog
        //Pfeilrichtung
        float winkel = (float)(Math.PI);
        //Lnge kleiner Pleil
		int lk = (int)(1.5*scale);
		//Lnge groer Pfeil
		int lg = (int)(2.5*scale);
		//Fupunkt unten klein
		int xfku = (int)(fixPktx*0.3);
		int yfku = (int)(fixPkty-scale*getH_keller());
		//Fupunkt in 8m klein
		int xfk8 = (int)xfku;
		int yfk8 = (int)(yfku-scale*8);
		//Fupunkt in 8m gro
		int xfg8 = xfk8+lg-lk;
		int yfg8 = yfk8;
		//Fupunkt genz oben gro
		int xfgo = xfg8;
		int yfgo = yfku-(int)(scale*getH_stielLinks());
		//Endpunkte in x-richtung
		int xeku = xfku-lk;
		int xek8 = xfk8-lk;
		int xeg8 = xfg8-lg;
		int xego = xfgo-lg;
		//Teilungsfaktoren
        float tk = (float)1/(8);
        float tg = (float)1.0/Math.round((yfk8-yfgo)/scale);
		//kleine Pfeile
		int yf=0;
        //Beschsriftung
		AffineTransform rot = new AffineTransform();
		rot.rotate(-Math.PI/2, xego , yfgo-lin);
        g2.setTransform(rot);
        g2.drawString("w (rechts, sog)",xego,yfgo-lin);
		rot.rotate(Math.PI/2, xego , yfgo-lin);
        g2.setTransform(rot);

        if(getH_stielLinks() > 8){
			//Begrenzungslinien
			g2.drawLine(xfku,yfku,xfk8,yfk8);
			g2.drawLine(xfg8,yfg8,xfgo,yfgo);
			g2.drawLine(xeku,yfku,xek8,yfk8);
			g2.drawLine(xeg8,yfg8,xego,yfgo);

			for(float i = 0 ; i <= 1 ; i+=tk ){
				yf=(int)(yfku-(yfku-yfk8)*i);
				setPfeil(new Point(xfku, yf), (float)(lk) , winkel , g2);
			}
            setPfeil(new Point(xfku, yfk8), (float)(lk) , winkel , g2);
			//groe Pfeile
			for(float i = 0 ; i <= 1 ; i+=tg){
				yf=(int)(yfg8-(yfg8-yfgo)*i);
				setPfeil(new Point(xfg8 ,yf), (float)(lg) , winkel , g2);
			}
            setPfeil(new Point(xfg8 ,yfgo), (float)(lg) , winkel , g2);
        }else{
            //Begrenzungslinien
            g2.drawLine(xfku,yfku,xfk8,yfgo);
            g2.drawLine(xeku,yfku,xek8,yfgo);
			for(float i = 0 ; i <= 1 ; i = (float)(i+=0.09)){
				yf=(int)(yfku-(yfku-yfgo)*i);
                setPfeil(new Point(xfku,yf), (float)(lk) , winkel , g2);
            }
        }

        //Wind von links druck
        //Pfeilrichtung
        winkel = (float)(Math.PI);
        //Lnge kleiner Pleil
		lk = (int)(-1.5*scale);
		//Lnge groer Pfeil
		lg = (int)(-2.5*scale);
		//Fupunkt unten klein
		xfku = (int)(fixPktx*0.3+ 3*scale);
		yfku = (int)(fixPkty-scale*getH_keller());
		//Fupunkt in 8m klein
		xfk8 = (int)xfku;
		yfk8 = (int)(yfku-scale*8);
		//Fupunkt in 8m gro
		xfg8 = xfk8+lg-lk;
		yfg8 = yfk8;
		//Fupunkt genz oben gro
		xfgo = xfg8;
		yfgo = yfku-(int)(scale*getH_stielLinks());
		//Endpunkte in x-richtung
		xeku = xfku-lk;
		xek8 = xfk8-lk;
		xeg8 = xfg8-lg;
		xego = xfgo-lg;
		//Teilungsfaktoren
        tk = (float)1/(8);
        tg = tg = (float)1.0/Math.round((yfk8-yfgo)/scale);
		//kleine Pfeile
		yf=0;
        //Beschsriftung
		rot.rotate(-Math.PI/2, xfgo , yfgo-lin);
        g2.setTransform(rot);
        g2.drawString("w (links, druck)",xfgo,yfgo-lin);
		rot.rotate(Math.PI/2, xfgo , yfgo-lin);
        g2.setTransform(rot);
        if(getH_stielLinks() > 8){
			//Begrenzungslinien
			g2.drawLine(xfku,yfku,xfk8,yfk8);
			g2.drawLine(xfg8,yfg8,xfgo,yfgo);
			g2.drawLine(xeku,yfku,xek8,yfk8);
			g2.drawLine(xeg8,yfg8,xego,yfgo);

			for(float i = 0 ; i <= 1 ; i+=tk ){
				yf=(int)(yfku-(yfku-yfk8)*i);
				setPfeil(new Point(xfku, yf), (float)(lk) , winkel , g2);
			}
            setPfeil(new Point(xfku, yfk8), (float)(lk) , winkel , g2);
			//groe Pfeile
			for(float i = 0 ; i <= 1 ; i+=tg){
				yf=(int)(yfg8-(yfg8-yfgo)*i);
				setPfeil(new Point(xfg8 ,yf), (float)(lg) , winkel , g2);
			}
            setPfeil(new Point(xfg8 ,yfgo), (float)(lg) , winkel , g2);
        }else{
            //Begrenzungslinien
            g2.drawLine(xfku,yfku,xfk8,yfgo);
            g2.drawLine(xeku,yfku,xek8,yfgo);
			for(float i = 0 ; i <= 1 ; i = (float)(i+=0.09)){
				yf=(int)(yfku-(yfku-yfgo)*i);
                setPfeil(new Point(xfku,yf), (float)(lk) , winkel , g2);
            }
        }

        //Wind von links sog
        //Pfeilrichtung
        winkel = (float)(Math.PI);
        //Lnge kleiner Pleil
		lk = (int)(-1.5*scale);
		//Lnge groer Pfeil
		lg = (int)(-2.5*scale);
		//Fupunkt unten klein
		xfku = (int)(fixPktx+scale*(getB_riegel()+2.7));
		yfku = (int)(fixPkty-scale*getH_keller());
		//Fupunkt in 8m klein
		xfk8 = (int)xfku;
		yfk8 = (int)(yfku-scale*8);
		//Fupunkt in 8m gro
		xfg8 = xfk8+lg-lk;
		yfg8 = yfk8;
		//Fupunkt genz oben gro
		xfgo = xfg8;
		yfgo = yfku-(int)(scale*getH_stielRechts());
		//Endpunkte in x-richtung
		xeku = xfku-lk;
		xek8 = xfk8-lk;
		xeg8 = xfg8-lg;
		xego = xfgo-lg;
		//Teilungsfaktoren
        tk = (float)1/(8);
        tg = tg = (float)1.0/Math.round((yfk8-yfgo)/scale);
		//kleine Pfeile
		yf=0;
        //Beschsriftung
		rot.rotate(-Math.PI/4, xfgo , yfgo-lin);
        g2.setTransform(rot);
        g2.drawString("w (links, sog)",xfgo,yfgo-lin);
		rot.rotate(Math.PI/4, xfgo , yfgo-lin);
        g2.setTransform(rot);

        if(getH_stielRechts() > 8){
			//Begrenzungslinien
			g2.drawLine(xfku,yfku,xfk8,yfk8);
			g2.drawLine(xfg8,yfg8,xfgo,yfgo);
			g2.drawLine(xeku,yfku,xek8,yfk8);
			g2.drawLine(xeg8,yfg8,xego,yfgo);

			for(float i = 0 ; i <= 1 ; i+=tk ){
				yf=(int)(yfku-(yfku-yfk8)*i);
				setPfeil(new Point(xfku, yf), (float)(lk) , winkel , g2);
			}
            setPfeil(new Point(xfku, yfk8), (float)(lk) , winkel , g2);
			//groe Pfeile
			for(float i = 0 ; i <= 1 ; i+=tg){
				yf=(int)(yfg8-(yfg8-yfgo)*i);
				setPfeil(new Point(xfg8 ,yf), (float)(lg) , winkel , g2);
			}
            setPfeil(new Point(xfg8 ,yfgo), (float)(lg) , winkel , g2);
        }else{
            //Begrenzungslinien
            g2.drawLine(xfku,yfku,xfk8,yfgo);
            g2.drawLine(xeku,yfku,xek8,yfgo);
			for(float i = 0 ; i <= 1 ; i = (float)(i+=0.09)){
				yf=(int)(yfku-(yfku-yfgo)*i);
                setPfeil(new Point(xfku,yf), (float)(lk) , winkel , g2);
            }
        }

        //Wind von rechts druck
        //Pfeilrichtung
        winkel = (float)(Math.PI);
        //Lnge kleiner Pleil
		lk = (int)(1.5*scale);
		//Lnge groer Pfeil
		lg = (int)(2.5*scale);
		//Fupunkt unten klein
		xfku = (int)(fixPktx+scale*(getB_riegel()+6.5));
		yfku = (int)(fixPkty-scale*getH_keller());
		//Fupunkt in 8m klein
		xfk8 = (int)xfku;
		yfk8 = (int)(yfku-scale*8);
		//Fupunkt in 8m gro
		xfg8 = xfk8+lg-lk;
		yfg8 = yfk8;
		//Fupunkt genz oben gro
		xfgo = xfg8;
		yfgo = yfku-(int)(scale*getH_stielRechts());
		//Endpunkte in x-richtung
		xeku = xfku-lk;
		xek8 = xfk8-lk;
		xeg8 = xfg8-lg;
		xego = xfgo-lg;
		//Teilungsfaktoren
        tk = (float)1/(8);
        tg = tg = (float)1.0/Math.round((yfk8-yfgo)/scale);
		//kleine Pfeile
		yf=0;
        //Beschsriftung
		rot.rotate(-Math.PI/4, xego , yfgo-lin);
        g2.setTransform(rot);
        g2.drawString("w (links, druck)",xego,yfgo-lin);
		rot.rotate(Math.PI/4, xego , yfgo-lin);
        g2.setTransform(rot);

        if(getH_stielRechts() > 8){
			//Begrenzungslinien
			g2.drawLine(xfku,yfku,xfk8,yfk8);
			g2.drawLine(xfg8,yfg8,xfgo,yfgo);
			g2.drawLine(xeku,yfku,xek8,yfk8);
			g2.drawLine(xeg8,yfg8,xego,yfgo);

			for(float i = 0 ; i <= 1 ; i+=tk ){
				yf=(int)(yfku-(yfku-yfk8)*i);
				setPfeil(new Point(xfku, yf), (float)(lk) , winkel , g2);
			}
            setPfeil(new Point(xfku, yfk8), (float)(lk) , winkel , g2);
			//groe Pfeile
			for(float i = 0 ; i <= 1 ; i+=tg){
				yf=(int)(yfg8-(yfg8-yfgo)*i);
				setPfeil(new Point(xfg8 ,yf), (float)(lg) , winkel , g2);
			}
            setPfeil(new Point(xfg8 ,yfgo), (float)(lg) , winkel , g2);
        }else{
            //Begrenzungslinien
            g2.drawLine(xfku,yfku,xfk8,yfgo);
            g2.drawLine(xeku,yfku,xek8,yfgo);
			for(float i = 0 ; i <= 1 ; i = (float)(i+=0.09)){
				yf=(int)(yfku-(yfku-yfgo)*i);
                setPfeil(new Point(xfku,yf), (float)(lk) , winkel , g2);
            }
        }
    }

    /**
     * Erdlasten antragen
     */
    private void setErdlast(Graphics2D g2){
   		//Dickenskalierung
        g2.setStroke(new BasicStroke(lin/4));

        //Pfeilrichtung
        float winkel = 0;
        //Lnge der Pleile
		int le = (int)(2*scale);
		//Fupunkt unten person
		int xfup = (int)(fixPktx*0.25);
		int yfup = (int)(fixPkty);
		//Fupunkt unten erd
		int xfue = (int)(xfup+3*scale);
		int yfue = yfup;
		//Fupunkt oben person
		int xfop = xfup;
		int yfop = (int)(yfup-scale*getH_keller());
		//Fupunkt oben erd
		int xfoe = xfue+le;
		int yfoe = yfop;
		//Endpunkte in x-richtung
		int xeup = xfup+le;
		int xeop = xeup;
		int xeue = xfue+le;
		//Teilungsfaktor
        float te = (float)(1.0/Math.round((yfup-yfop)/scale));

		//Personenlast
		int yf=0;
        //Beschsriftung
		AffineTransform rot = new AffineTransform();
		rot.rotate(-Math.PI/2, xfup-lin , yfup);
        g2.setTransform(rot);
        g2.drawString("p ( ahp )",xfup-lin ,yfup);
		rot.rotate(Math.PI/2, xfup-lin , yfup);
        g2.setTransform(rot);

		//Begrenzungslinien
		g2.drawLine(xfup,yfup,xfop,yfop);
		g2.drawLine(xeup,yfup,xeop,yfop);

		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfup -(yfup-yfop)*i);
			setPfeil(new Point(xfup, yf), (float)(le) , winkel , g2);
		}
		setPfeil(new Point(xfop, yfop), (float)(le) , winkel , g2);

		//Erdlast
		yf=0;
        //Beschsriftung
		rot.rotate(-Math.PI/2, xfue-lin , yfup);
        g2.setTransform(rot);
        g2.drawString("p ( ahg )",xfue-lin ,yfup);
		rot.rotate(Math.PI/2, xfue-lin , yfup);
        g2.setTransform(rot);

		for(float i = 0 ; i <= 1 ; i+=te){
			    yf=(int)(yfue -(yfue-yfoe)*i);
 			int xf=(int)(xfue+le*i);
			setPfeil(new Point(xf ,yf), (float)(le*(1-i)) , winkel , g2);
		}
		//Begrenzungslinien
		g2.drawLine(xfue,yfue,xfoe,yfoe);
		g2.drawLine(xeue,yfue,xfoe,yfoe);

    }

    /**
     * Auflasten auf den Riegel (Eigengewicht Schnee und Windsog
     */
    private void setAuflasten(Graphics2D g2){
   		//Dickenskalierung
        g2.setStroke(new BasicStroke(lin/4));

        //Windsog
        //Pfeilrichtung
        float winkel =(float)(-Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel())-Math.PI/2);
        //Riegelrichtung
        float wri = (float)(Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel()));
        //Lnge der Pleile
		int le = (int)(1.5*scale);
		//Fupunkt links
		int xfl = (int)(fixPktx);
		int yfl = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks())-1*lin);
		//Fupunkt rechts
		int xfr = (int)(xfl+scale*getB_riegel());
		int yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts())-1*lin);
		//Endpunkt links
		int xel = (int)(xfl-Math.sin(wri)*le);
		int yel = (int)(yfl-Math.cos(wri)*le);
		//Endpunkt rechts
		int xer = (int)(xfr-Math.sin(wri)*le);
		int yer = (int)(yfr-Math.cos(wri)*le);
		//Teilungsfaktor
        float te = (float)(1.0/Math.round((xfr-yfl)/scale));

		int yf=0;
        int xf=0;
        //Beschsriftung
		AffineTransform rot = new AffineTransform();
		rot.rotate(-Math.PI/4, xer+lin , yer);
        g2.setTransform(rot);
        g2.drawString("w ( sog )",xer+lin ,yer);
		rot.rotate(Math.PI/4,  xer+lin , yer);
        g2.setTransform(rot);

		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);

		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			setPfeil(new Point(xf, yf), (float)(le) , winkel , g2);
		}
		setPfeil(new Point(xfr, yfr), (float)(le) , winkel , g2);

        //Eigengewicht
        //Pfeilrichtung
        winkel =(float)(-Math.PI/2);
        //Lnge der Pleile
		le = (int)(-1.5*scale);
		//Fupunkt links
		xfl = (int)(fixPktx);
		yfl = (int)(fixPkty-scale*(getH_keller() + Math.max(getH_stielLinks(),getH_stielRechts()))+2.5*le);
		//Fupunkt rechts
		xfr = (int)(xfl+scale*getB_riegel());
		yfr = yfl;
		//Endpunkt links
		xel = xfl;
		yel = yfl-le;
		//Endpunkt rechts
		xer = xfr;
		yer = yel;
		//Teilungsfaktor
        te = (float)(1.0/Math.round((xfr-yfl)/scale));

		yf=0;
        xf=0;
        //Beschsriftung
        g2.drawString("g ( Dach )",xfr+lin ,yfr);

		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);

		for(float i = 0 ; i <= 1 ; i+=te ){
            xf=(int)(xfl + (xfr-xfl)*i);
			setPfeil(new Point(xf, yfl), (float)(le) , winkel , g2);
		}
		setPfeil(new Point(xfr, yfr), (float)(le) , winkel , g2);

        //Schnee
        //Pfeilrichtung
        winkel =(float)(-Math.PI/2);
        //Lnge der Pleile
		le = (int)(-1.5*scale);
		//Fupunkt links
		xfl = (int)(fixPktx);
		yfl = (int)(fixPkty-scale*(getH_keller() + Math.max(getH_stielLinks(),getH_stielRechts()))+4.5*le);
		//Fupunkt rechts
		xfr = (int)(xfl+scale*getB_riegel());
		yfr = yfl;
		//Endpunkt links
		xel = xfl;
		yel = yfl-le;
		//Endpunkt rechts
		xer = xfr;
		yer = yel;
		//Teilungsfaktor
        te = (float)(1.0/Math.round((xfr-yfl)/scale));

		yf=0;
        xf=0;
        //Beschsriftung
        g2.drawString(" s ",xfr+lin ,yfr);

		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);

		for(float i = 0 ; i <= 1 ; i+=te ){
            xf=(int)(xfl + (xfr-xfl)*i);
			setPfeil(new Point(xf, yfl), (float)(le) , winkel , g2);
		}
		setPfeil(new Point(xfr, yfr), (float)(le) , winkel , g2);

		//Eigengewicht linker Stiel
   		setPfeil(new Point(xfl, yfl+2*le), (float)(1.5*le) , winkel , g2);
        g2.drawString("g (linker Stiel) " , xfl+lin , yfl-2*lin);
		//Eigengewicht rechter Stiel
   		setPfeil(new Point(xfr, yfr+2*le), (float)(1.5*le) , winkel , g2);
        int wortLaenge =(int)((FontMetrics)g2.getFontMetrics()).stringWidth("g (rechter Stiel) ");
        g2.drawString("g (rechter Stiel) " , xfr-lin-wortLaenge , yfr-2*lin);

    }



    /**
     * Hhe des Kellers in [m]
     */
    private double h_keller = 0.0;
    /**
     * Setzt die Hhe des Kellers in [m]
     * @param h_keller - Hhe des Kellers in [m]
     */
    void setH_keller(double h_keller){
        this.h_keller = h_keller;
    	repaint();
    }
    /**
     * Liefert die Hhe des Kellers in [m]
     * @return Hhe des Kellers in [m]
     */
    private float getH_keller(){return (float)h_keller;}

    /**
     * Hhe des linken Stiels in [m]
     */
    private double h_stielLinks = 0.0;
    /**
     * Setzt die Hhe des linken Stiels in [m]
     * @param h_stielLinks - Hhe des linken Stiels in [m]
     */
    void setH_stielLinks(double h_stielLinks){
        this.h_stielLinks = h_stielLinks;
        repaint();
    }
    /**
     * Liefert die Hhe des linken Stiels in [m]
     * @return Hhe des linken Stiels in [m]
     */
    private float getH_stielLinks(){return (float)h_stielLinks;}

    /**
     * Hhe des rechten Stiels in [m]
     */
    private double h_stielRechts = 0.0;
    /**
     * Setzt die Hhe des rechten Stiels in [m]
     * @param h_stielRechts - Hhe des rechten Stiels in [m]
     */
    void setH_stielRechts(double h_stielRechts){
        this.h_stielRechts = h_stielRechts;
        repaint();
    }
    /**
     * Liefert die Hhe des rechten Stiels in [m]
     * @return Hhe des rechten Stiels in [m]
     */
    private float getH_stielRechts(){return (float)h_stielRechts;}

    /**
     * Breite des Riegels in [m]
     */
    private double b_riegel = 0.0;
    /**
     * Setzt die Breite des Riegels in [m]
     * @param b_riegel - Breite des Riegels in [m]
     */
    void setB_riegel(double b_riegel){
        this.b_riegel = b_riegel;
        repaint();}
    /**
     * Liefert die Breite des Riegels in [m]
     * @return Breite des Riegels in [m]
     */
    private float getB_riegel(){return (float)b_riegel;}

    /**
     * Momentengelenk links oben
     */
    private boolean gelLinks = true;
    /**
     * Setzt Momentengelenk links oben
     * @param gelLinks - Momentengelenk links oben
     */
    void setGelLinks(boolean gelLinks){
        this.gelLinks = gelLinks;
        repaint();
    }
    /**
     * Liefert Momentengelenk links oben
     * @return Momentengelenk links oben
     */
    private boolean getGelLinks(){return gelLinks;}

    /**
     * Momentengelenk rechts oben
     */
    private boolean gelRechts = true;
    /**
     * Setzt Momentengelenk rechts oben
     * @param gelRechts - Momentengelenk rechts oben
     */
    void setGelRechts(boolean gelRechts){
        this.gelRechts = gelRechts;
        repaint();
    }
    /**
     * Liefert Momentengelenk rechts oben
     * @return Momentengelenk rechts oben
     */
    private boolean getGelRechts(){return gelRechts;}


    /**
     * Der Skalierungsfaktor
     */
    private float scale = 1;
    /**
     * Fixpunkt unten rechts
     */
    private float fixPktx = 0;
    private float fixPkty = 0;
    /**
     * Liniendicken
     */
    private float lin = 0;
    /**
     * Breite und Hhe des Panels
     */
    private int l = 0;
	private	int h = 0;

}
