/* Generated by Together */

package gui;

import javax.swing.JPanel;
import java.awt.Label;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.FocusListener;
import java.awt.event.FocusEvent;

class JPanelLastStielRechts extends JPanel {
    /** Creates new form JPanelLastStiel */
    JPanelLastStielRechts() {
        initGUI();
    }

    /** This method is called from within the constructor to initialize the form. */
    private void initGUI() {
		this.setLayout(new GridLayout(2, 1));
        add(jPanelGewicht);
        add(jPanelWind);
		/**
         * Panel fr die Eigenlast
         */
		//Panel konfigurieren
        jPanelGewicht.setLayout(new java.awt.GridLayout(9, 1));
        jPanelGewicht.setBorder(javax.swing.BorderFactory.createEtchedBorder());
		//Namen konfigurieren
        jLabelName.setText("Gewichtskraft rechts");
        jLabelName.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jLabelName.setFont(new java.awt.Font("SansSerif", java.awt.Font.BOLD, 14));
        jLabelName.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		//Eigenlast
        jLabelEigenlast.setText("Eigenlast in [MN/m]");
        jTextFieldEigenlast.setEditable(false);
		//Aufbauten
        jLabelAufbauten.setText("g Aufbauten in [MN/m]");
        jTextFieldAufbauten.addFocusListener( new FocusListener(){
                //berprft die Eingabe
                public void focusGained(FocusEvent ev){}
				public void focusLost(FocusEvent ev){
                    boolean trigger = true;
                    double wert = 0.0;
                    double alt = getAufbauten();
                    try{
                        wert = Double.parseDouble(jTextFieldAufbauten.getText());
                    }catch(NumberFormatException nfex){
                        trigger = false;
                    }
                    setAufbauten(trigger ? wert : alt);
				}
        		});
		//Stiel
        jLabelGStiel.setText("g in [MN]");
        jTextFieldGStiel.setEditable(false);
		//Komponenten hinzufgen
        jPanelGewicht.add(jLabelName);
        jPanelGewicht.add(jLabelEigenlast);
        jPanelGewicht.add(jTextFieldEigenlast);
        jPanelGewicht.add(jLabelAufbauten);
        jPanelGewicht.add(jTextFieldAufbauten);
        jPanelGewicht.add(jLabelGStiel);
        jPanelGewicht.add(jTextFieldGStiel);



		/**
         * Panel fr die Windlasten
         */
        jPanelWind.setLayout(new GridLayout(11,1));
        jPanelWind.setBorder(javax.swing.BorderFactory.createEtchedBorder());
		//Namen konfigurieren
        jLabelWindLasten.setText("Windlasten");
        jLabelWindLasten.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        jLabelWindLasten.setFont(new java.awt.Font("SansSerif", java.awt.Font.BOLD, 14));
        jLabelWindLasten.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        //Winddruck 0 - 8m
        jLabelWindDruck0_8.setText("w (Druck 0-8m) in [MN/m]");
        jTextFieldWindDruck0_8.setEditable(false);
        //Winddruck 8 - 20m
        jLabelWindDruck8_20.setText("w (Druck 8-20m) in [MN/m]");
        jTextFieldWindDruck8_20.setEditable(false);
        //Windsog 0 - 8m
        jLabelWindSog0_8.setText("w (Sog 0-8m) in [MN/m]");
        jTextFieldWindsog0_8.setEditable(false);
        //Windsog 8 - 20m
        jLabelWindSog8_20.setText("w (Sog 8-20m) in [MN/m]");
        jTextFieldWindsog8_20.setEditable(false);
        //Windsog Dach
        jLabelWindSog.setText("w (Sog) in [MN/m]");
        jTextFieldWindsog.setEditable(false);
		//Komponenten hinzufgen
        jPanelWind.add(jLabelWindLasten);
        jPanelWind.add(jLabelWindDruck0_8);
        jPanelWind.add(jTextFieldWindDruck0_8);
        jPanelWind.add(jLabelWindDruck8_20);
        jPanelWind.add(jTextFieldWindDruck8_20);
        jPanelWind.add(jLabelWindSog0_8);
        jPanelWind.add(jTextFieldWindsog0_8);
        jPanelWind.add(jLabelWindSog8_20);
        jPanelWind.add(jTextFieldWindsog8_20);
        jPanelWind.add(jLabelWindSog);
        jPanelWind.add(jTextFieldWindsog);


    }
	/**
     * Flchenlast der Aufbauten in [MN/m]
     */
    private double aufbauten;
	/**
     * Liefert die Flchenlast der Aufbauten in [MN/m]
     * @return Flchenlast der Aufbauten in [MN/m]
     */
    double getAufbauten(){ return aufbauten; }
    /**
     * Setzt die Flchenlast der Aufbauten in [MN/m]
     * @param aufbauten - Flchenlast der Aufbauten in [MN/m]
     */
    void setAufbauten(double aufbauten){
        double oldAufbauten = getAufbauten();
        this.aufbauten = aufbauten;
        jTextFieldAufbauten.setText(Double.toString(aufbauten));
        firePropertyChange("aufbauten", new Double(oldAufbauten), new Double(aufbauten));
    }
    /**
     * Setzt die Gewichtskraft des Stiels in [MN/m]
     * @param Setzt die Gewichtskraft des Stiels in [MN/m]
     */
    void setEigenlast(double last){
        String wert = Double.toString(last);
        wert = wert.substring(0 , wert.length() < 8 ? wert.length() : 8);
        jTextFieldEigenlast.setText(wert);
	}

    /**
     * Setzt gesamte Gewichtskraft des Stiels in [MN]
     * @param gesamte Gewichtskraft des Stiels in [MN]
     */
    void setGewichtskraft(double last){
        String wert = Double.toString(last);
        wert = wert.substring(0 , wert.length() < 8 ? wert.length() : 8);
        jTextFieldGStiel.setText(wert);
	}

    /**
     * Setzt Winddruck in [MN/m] von 0 - 8m
     * @param wert - Winddruck in [MN/m] von 0 - 8m
     */
    void setWinddruck0_8(double last){
        String wert = Double.toString(last);
        wert = wert.substring(0 , wert.length() < 8 ? wert.length() : 8);
        jTextFieldWindDruck0_8.setText(wert);
	}

    /**
     * Setzt Winddruck in [MN/m] von 8 - 20m
     * @param wert - Winddruck in [MN/m] von 8 - 20m
     */
    void setWinddruck8_20(double last){
        String wert = Double.toString(last);
        wert = wert.substring(0 , wert.length() < 8 ? wert.length() : 8);
        jTextFieldWindDruck8_20.setText(wert);
	}

    /**
     * Setzt Windsog in [MN/m] von 0 - 8m
     * @param wert - Windsog in [MN/m] von 0 - 8m
     */
    void setWindsog0_8(double last){
        String wert = Double.toString(last);
        wert = wert.substring(0 , wert.length() < 8 ? wert.length() : 8);
        jTextFieldWindsog0_8.setText(wert);
	}

    /**
     * Setzt Windsog in [MN/m] von 8 - 20m
     * @param wert - Windsog in [MN/m] von 8 - 20m
     */
    void setWindsog8_20(double last){
        String wert = Double.toString(last);
        wert = wert.substring(0 , wert.length() < 8 ? wert.length() : 8);
        jTextFieldWindsog8_20.setText(wert);
	}
    /**
     * Setzt Windsog in [MN/m] am Dach
     * @param wert - Windsog in [MN/m] am Dach
     */
    void setWindsog(double last){
        String wert = Double.toString(last);
        wert = wert.substring(0 , wert.length() < 8 ? wert.length() : 8);
        jTextFieldWindsog.setText(wert);
	}

    //Name
	private JLabel jLabelName = new JLabel();
	//Panele
    private JPanel jPanelGewicht = new JPanel();
    private JPanel jPanelWind = new JPanel();
    //Eigenlast
    private JLabel jLabelEigenlast = new JLabel();
    private JTextField jTextFieldEigenlast = new JTextField();
    //Aufbauten
    private JLabel jLabelAufbauten = new JLabel();
    private JTextField jTextFieldAufbauten = new JTextField();
    //Gesamtlast
    private JLabel jLabelGStiel = new JLabel();
    private JTextField jTextFieldGStiel = new JTextField();
	//Name Windlasten
    private JLabel jLabelWindLasten = new JLabel();
    //Winddruck von 0 - 8m
    private JLabel jLabelWindDruck0_8 = new JLabel();
    private JTextField jTextFieldWindDruck0_8 = new JTextField();
    //Winddruck von 8 - 20m
    private JLabel jLabelWindDruck8_20 = new JLabel();
    private JTextField jTextFieldWindDruck8_20 = new JTextField();
    //Windsog von 0 - 8m
    private JLabel jLabelWindSog0_8 = new JLabel();
    private JTextField jTextFieldWindsog0_8 = new JTextField();
    //Windsog von 8 - 20m
    private JLabel jLabelWindSog8_20 = new JLabel();
    private JTextField jTextFieldWindsog8_20 = new JTextField();
    //Windsog dach
    private JLabel jLabelWindSog = new JLabel();
    private JTextField jTextFieldWindsog = new JTextField();

}
