/* Generated by Together */

package gui;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.GeneralPath;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.geom.QuadCurve2D.Float;
import java.awt.geom.QuadCurve2D;
import java.awt.Stroke;


/**
 * Zeichnet die Normalkrfte im System 
 */
final class JPanelSchnittRahmenMoment extends JPanelSchnittRahmen {
    public JPanelSchnittRahmenMoment() {
    }
	/**
     * Konstruktor mit allen ntigen Werten fr einen Grundrahmen
     * @param keller - Hhe des Kellers in [m]
     *        links  - Hhe des linken Stiels in [m]
     *        oben   - Breite des Riegels in [m]
     *        rechts - Hhe des rechten Stiels in [m]
     *        gelLinks - Gelenk oben links [boolean]
     *        gelRechts - Gelenk oben rechts [boolean]
     */
    public JPanelSchnittRahmenMoment(  double keller ,
										   double links ,
										   double oben ,
										   double rechts ,
										   boolean gelLinks ,
										   boolean gelRechts ,
                                           double m22 ,
                                           double m33 ,
                                           double m34 ,
                                           double m44 ,
                                           double m45){
    	//Konstruktor des Superklasse aufrufen
		super(keller , links , oben , rechts , gelLinks , gelRechts);
        this.m22 = m22;
        this.m33 = m33;
        this.m34 = m34;
        this.m44 = m44;
        this.m45 = m45;
    }


    /**
     * ber vererbungsinverse Ablikation knnen hier die Schnittkrfte
     * gezeichnet werden.
     * @param fixPktx - Fixpunkt unten links x - koordinate
     *        fixPkty - Fixpunkt unten links y - koordinate
     *        scale   - Scalierungsfaktor von [m] auf Pix
     *        g2      - Graphics Referenz
     */
    protected void setSchnittgroessen(float fixPktx ,
                                      float fixPkty ,
                                      float scale ,
                                      Graphics2D g2){

        //Dickenskalierung
      	g2.setFont(new Font("Serif" , Font.PLAIN, 16));
        g2.drawString("Die blauen Linien sollen nur auf den",10,20);
        g2.drawString("analytischen Verlauf hinweisen.", 10,40);
        g2.drawString("Es handelt sich dabei nicht um eine Interpolation!",10,60);
        g2.setStroke(new BasicStroke(1));
        g2.setColor(Color.red);
//M Riegel
        //Schraffurrichtung
        float winkel =(float)(-Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel())-Math.PI/2);
        //Riegelrichtung
        float wri = (float)(Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel()));
        //Lnge der Schraffur am linken Rand
		int ll = (int)(-m33*scale*5);
        //Lnge der Schraffur am rechten Rand
		int lr = (int)(-m44*scale*5);
		//Fupunkt links
		int xfl = (int)(fixPktx);
		int yfl = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks())-1*lin);
		//Fupunkt rechts
		int xfr = (int)(xfl+scale*getB_riegel());
		int yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts())-1*lin);
		//Endpunkt links
		int xel = (int)(xfl-Math.sin(wri)*ll);
		int yel = (int)(yfl-Math.cos(wri)*ll);
		//Endpunkt rechts
		int xer = (int)(xfr-Math.sin(wri)*lr);
		int yer = (int)(yfr-Math.cos(wri)*lr);
		//Teilungsfaktor
        float te = (float)(1.0/Math.round((xfr-xfl)/scale));
		int yf=0;
        int xf=0;
        float ls = 0;
		//Beschriftung
        int wortLaenge= 0;
        Color alt = g2.getColor();
        g2.setColor(Color.black);
        String m44S = String.valueOf(m44);
        m44S = m44S.substring(0, m44S.length() > 6 ? 6 : m44S.length());
        String m33S = String.valueOf(m33);
        m33S = m33S.substring(0, m33S.length() > 6 ? 6 : m33S.length());
        String m34S = String.valueOf(m34);
        m34S = m34S.substring(0, m34S.length() > 6 ? 6 : m34S.length());
        wortLaenge =((FontMetrics)g2.getFontMetrics()).stringWidth("M = "+String.valueOf(m44S)+"MNm");
        g2.drawString("M = "+String.valueOf(m44S)+"MNm",xfr-(int)(wortLaenge*0.5),yer-10);
        g2.drawString("M = "+String.valueOf(m33S)+"MNm",xfl-(int)(wortLaenge*0.5),yel-10);
        g2.drawString("M = "+String.valueOf(m34S)+"MNm",(int)((xfl+xfr-wortLaenge)*0.5),yfl-10);
        g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
		//Maximum eintragen
        Stroke linalt = g2.getStroke();
        float[] dash = { 5 , 5 };
        g2.setStroke(new BasicStroke(1 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER , 1 , dash , 0));
        alt = g2.getColor();
        g2.setColor(Color.blue);
        float lmax = (float)(-m34*scale*5);
        float xmaxf = (float)(xfl + (xfr-xfl)*0.5);
        float ymaxf = (float)(yfl +(yfr-yfl)*0.5);
        float xmaxe  = (float)(Math.cos(winkel)*lmax)+xmaxf;
        float ymaxe = (float)(Math.sin(winkel)*lmax)+ymaxf;
        GeneralPath kurve = new GeneralPath();
        kurve.moveTo(xfl,yfl);
        kurve.lineTo(xel,yel);
        kurve.curveTo(xmaxe,ymaxe,xmaxe,ymaxe,xer,yer);
        kurve.lineTo(xfr,yfr);
		g2.draw(kurve);
        g2.setColor(alt);
        g2.setStroke(linalt);
//M Keller
        //Schraffurrichtung
        winkel =(float)Math.PI;
        //Lnge der Schraffur am linken Rand
		ll = (int)(0*scale*5);
        //Lnge der Schraffur am rechten Rand
		lr = (int)(-m22*scale*5);
		//Fupunkt links
		xfl = (int)(fixPktx);
		yfl = (int)(fixPkty);
		//Fupunkt rechts
		xfr = xfl;
		yfr = (int)(fixPkty-scale*(getH_keller()));
		//Endpunkt links
		xel = (int)(xfl-ll);
		yel = (int)(yfl);
		//Endpunkt rechts
		xer = (int)(xfr-lr);
		yer = (int)(yfr);
		//Teilungsfaktor
        te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
		yf=0;
        xf=0;
        ls = 0;
		//Beschriftung
		alt = g2.getColor();
		g2.setColor(Color.black);
        String m22S = String.valueOf(m22);
        m22S = m22S.substring(0, m22S.length() > 6 ? 6 : m22S.length());
		g2.drawString("M = "+String.valueOf(m22S)+"MNm",xel+10,yfr+20);
		g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
   		//Maximum eintragen
        linalt = g2.getStroke();
        g2.setStroke(new BasicStroke(1 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER , 1 , dash , 0));
        alt = g2.getColor();
        g2.setColor(Color.blue);
        kurve = new GeneralPath();
        kurve.moveTo(xfl,yfl);
        kurve.lineTo(xel,yel);
        kurve.quadTo((float)(xfl),(float)((yfl+yfr)*0.5),xer,yer);
        kurve.lineTo(xfr,yfr);
		g2.draw(kurve);
        g2.setColor(alt);
        g2.setStroke(linalt);
//M links
        //Schraffurrichtung
        winkel =(float)Math.PI;
        //Lnge der Schraffur am linken Rand
		ll = (int)(-m22*scale*5);
        //Lnge der Schraffur am rechten Rand
		lr = (int)(-m33*scale*5);
		//Fupunkt links
		xfl = (int)(fixPktx);
		yfl = (int)(fixPkty-scale*getH_keller());
		//Fupunkt rechts
		xfr = xfl;
		yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks()));
		//Endpunkt links
		xel = (int)(xfl-ll);
		yel = (int)(yfl);
		//Endpunkt rechts
		xer = (int)(xfr-lr);
		yer = (int)(yfr);
		//Teilungsfaktor
        te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
		yf=0;
        xf=0;
        ls = 0;
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
   		//Maximum eintragen
        linalt = g2.getStroke();
        g2.setStroke(new BasicStroke(1 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER , 1 , dash , 0));
        alt = g2.getColor();
        g2.setColor(Color.blue);
        kurve = new GeneralPath();
        kurve.moveTo(xfl,yfl);
        kurve.lineTo(xel,yel);
        kurve.quadTo((float)(xfl),(float)((yfl+yfr)*0.5),xer,yer);
        kurve.lineTo(xfr,yfr);
		g2.draw(kurve);
        g2.setColor(alt);
        g2.setStroke(linalt);
//M Rechts
        //Schraffurrichtung
        winkel =(float)Math.PI;
        //Lnge der Schraffur am linken Rand
		ll = (int)(0*scale*5);
        //Lnge der Schraffur am rechten Rand
		lr = (int)(m44*scale*5);
		//Fupunkt links
		xfl = (int)(fixPktx+scale*getB_riegel());
		yfl = (int)(fixPkty-scale*getH_keller());
		//Fupunkt rechts
		xfr = xfl;
		yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts()));
		//Endpunkt links
		xel = (int)(xfl-ll);
		yel = (int)(yfl);
		//Endpunkt rechts
		xer = (int)(xfr-lr);
		yer = (int)(yfr);
		//Teilungsfaktor
        te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
		yf=0;
        xf=0;
        ls = 0;
		//Beschriftung
		alt = g2.getColor();
		g2.setColor(Color.black);
        String m45S = String.valueOf(m45);
        m45S = m45S.substring(0, m45S.length() > 6 ? 6 : m45S.length());
        int wortl = g2.getFontMetrics().stringWidth("M = "+m45S+"MNm");
		g2.drawString("M = "+m45S+"MNm",xel-wortl,(yfl+yfr)/2);
		g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
   		//Maximum eintragen
        linalt = g2.getStroke();
        g2.setStroke(new BasicStroke(1 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER , 1 , dash , 0));
        alt = g2.getColor();
        g2.setColor(Color.blue);
        kurve = new GeneralPath();
        kurve.moveTo(xfl,yfl);
        kurve.lineTo(xel,yel);
        kurve.quadTo((float)(xfl-scale*m45),(float)((yfl+yfr)*0.5),xer,yer);
        kurve.lineTo(xfr,yfr);
		g2.draw(kurve);
        g2.setColor(alt);
        g2.setStroke(linalt);
    }

    /**
     * Pfeile fr die Lasten
     * @param p - Fupunkt des Pfeils
     *        l - Lnge des Pfeils in Pix
     *        w - Winkel des Pfeils 0    -  3 Uhr
     *                              PI/2 - 12 Uhr
     * 								PI   -  9 Uhr...
     * 		 g2 - Zeichenobjekt
     */
    private void setSchraffur(Point p, float l, float w, Graphics2D g2){
		float sx = (float)p.getX();
        float sy = (float)p.getY();
        float zx = (float)(Math.cos(w)*l)+sx;
        float zy = (float)(Math.sin(w)*l)+sy;
        GeneralPath pfe = new GeneralPath();
        pfe.moveTo(sx, sy);
        pfe.lineTo(zx , zy);
		g2.draw(pfe);
    }


    private double m22 = 0;
    private double m33 = 0;
    private double m34 = 0;
    private double m44 = 0;
    private double m45 = 0;

    private float lin = 0;


}
