/* Generated by Together */

package gui;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.GeneralPath;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;


/**
 * Zeichnet die Normalkrfte im System 
 */
final class JPanelSchnittRahmenNormalkraft extends JPanelSchnittRahmen {
    public JPanelSchnittRahmenNormalkraft() {
    }
	/**
     * Konstruktor mit allen ntigen Werten fr einen Grundrahmen
     * @param keller - Hhe des Kellers in [m]
     *        links  - Hhe des linken Stiels in [m]
     *        oben   - Breite des Riegels in [m]
     *        rechts - Hhe des rechten Stiels in [m]
     *        gelLinks - Gelenk oben links [boolean]
     *        gelRechts - Gelenk oben rechts [boolean]
     */
    public JPanelSchnittRahmenNormalkraft( double keller ,
										   double links ,
										   double oben ,
										   double rechts ,
										   boolean gelLinks ,
										   boolean gelRechts ,
                                           double n13 ,
                                           double n33 ,
                                           double n44 ,
                                           double n45){
    	//Konstruktor des Superklasse aufrufen
		super(keller , links , oben , rechts , gelLinks , gelRechts);
        this.n13 = n13;
        this.n33 = n33;
        this.n44 = n44;
        this.n45 = n45;
    }


    /**
     * ber vererbungsinverse Ablikation knnen hier die Schnittkrfte
     * gezeichnet werden.
     * @param fixPktx - Fixpunkt unten links x - koordinate
     *        fixPkty - Fixpunkt unten links y - koordinate
     *        scale   - Scalierungsfaktor von [m] auf Pix
     *        g2      - Graphics Referenz
     */
    protected void setSchnittgroessen(float fixPktx ,
                                      float fixPkty ,
                                      float scale ,
                                      Graphics2D g2){

        //Dickenskalierung
        g2.setStroke(new BasicStroke(1));
        g2.setColor(Color.red);
      	g2.setFont(new Font("Serif" , Font.PLAIN, 16));
//N Riegel
        //Schraffurrichtung
        float winkel =(float)(-Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel())-Math.PI/2);
        //Riegelrichtung
        float wri = (float)(Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel()));
        //Lnge der Schraffur am linken Rand
		int ll = (int)(-n33*scale*15);
        //Lnge der Schraffur am rechten Rand
		int lr = (int)(-n44*scale*15);
		//Fupunkt links
		int xfl = (int)(fixPktx);
		int yfl = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks())-1*lin);
		//Fupunkt rechts
		int xfr = (int)(xfl+scale*getB_riegel());
		int yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts())-1*lin);
		//Endpunkt links
		int xel = (int)(xfl-Math.sin(wri)*ll);
		int yel = (int)(yfl-Math.cos(wri)*ll);
		//Endpunkt rechts
		int xer = (int)(xfr-Math.sin(wri)*lr);
		int yer = (int)(yfr-Math.cos(wri)*lr);
		//Teilungsfaktor
        float te = (float)(1.0/Math.round((xfr-xfl)/scale));
		int yf=0;
        int xf=0;
        float ls = 0;
		//Beschriftung
        int wortLaenge= 0;
        Color alt = g2.getColor();
        g2.setColor(Color.black);
        String n44S = String.valueOf(n44);
        n44S = n44S.substring(0, n44S.length() > 6 ? 6 : n44S.length());
        String n33S = String.valueOf(n33);
        n33S = n33S.substring(0, n33S.length() > 6 ? 6 : n33S.length());
        wortLaenge =((FontMetrics)g2.getFontMetrics()).stringWidth("N = "+String.valueOf(n44S)+"MN");
        g2.drawString("N = "+String.valueOf(n44S)+"MN",xfr-wortLaenge,yfr-10);
        g2.drawString("N = "+String.valueOf(n33S)+"MN",xfl,yfl-10);
        g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
//N Links
        //Schraffurrichtung
        winkel =(float)Math.PI;
        //Lnge der Schraffur am linken Rand
		ll = (int)(-n13*scale*10);
        //Lnge der Schraffur am rechten Rand
		lr = (int)(-n13*scale*10);
		//Fupunkt links
		xfl = (int)(fixPktx);
		yfl = (int)(fixPkty);
		//Fupunkt rechts
		xfr = xfl;
		yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks()));
		//Endpunkt links
		xel = (int)(xfl-ll);
		yel = (int)(yfl);
		//Endpunkt rechts
		xer = (int)(xfr-lr);
		yer = (int)(yfr);
		//Teilungsfaktor
        te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
		yf=0;
        xf=0;
        ls = 0;
		//Beschriftung
        alt = g2.getColor();
        g2.setColor(Color.black);
        String n13S = String.valueOf(n13);
        n13S = n13S.substring(0, n13S.length() > 6 ? 6 : n13S.length());
        g2.drawString("N = "+String.valueOf(n13S)+"MN",xfl+10,yfl-10);
        g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
//N Rechts
        //Schraffurrichtung
        winkel =(float)Math.PI;
        //Lnge der Schraffur am linken Rand
		ll = (int)(n45*scale*10);
        //Lnge der Schraffur am rechten Rand
		lr = (int)(n45*scale*10);
		//Fupunkt links
		xfl = (int)(fixPktx+scale*getB_riegel());
		yfl = (int)(fixPkty-scale*getH_keller());
		//Fupunkt rechts
		xfr = xfl;
		yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts()));
		//Endpunkt links
		xel = (int)(xfl-ll);
		yel = (int)(yfl);
		//Endpunkt rechts
		xer = (int)(xfr-lr);
		yer = (int)(yfr);
		//Teilungsfaktor
        te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
		yf=0;
        xf=0;
        ls = 0;
		//Beschriftung
        wortLaenge= 0;
        alt = g2.getColor();
        g2.setColor(Color.black);
        String n45S = String.valueOf(n45);
        n45S = n45S.substring(0, n45S.length() > 6 ? 6 : n45S.length());
        wortLaenge =((FontMetrics)g2.getFontMetrics()).stringWidth("N = "+String.valueOf(n45S)+"MN");
        g2.drawString("N = "+String.valueOf(n45S)+"MN",xfr-wortLaenge-10,yfl-10);
        g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
    }

    /**
     * Pfeile fr die Lasten
     * @param p - Fupunkt des Pfeils
     *        l - Lnge des Pfeils in Pix
     *        w - Winkel des Pfeils 0    -  3 Uhr
     *                              PI/2 - 12 Uhr
     * 								PI   -  9 Uhr...
     * 		 g2 - Zeichenobjekt
     */
    private void setSchraffur(Point p, float l, float w, Graphics2D g2){
		float sx = (float)p.getX();
        float sy = (float)p.getY();
        float zx = (float)(Math.cos(w)*l)+sx;
        float zy = (float)(Math.sin(w)*l)+sy;
        GeneralPath pfe = new GeneralPath();
        pfe.moveTo(sx, sy);
        pfe.lineTo(zx , zy);
		g2.draw(pfe);
    }


    private double n13 = 0;
    private double n33 = 0;
    private double n44 = 0;
    private double n45 = 0;

    private float lin = 0;


}
