/* Generated by Together */

package gui;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.GeneralPath;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Dimension;


/**
 * Zeichnet die Normalkrfte im System 
 */
final class JPanelSchnittRahmenQuerkraft extends JPanelSchnittRahmen {
    public JPanelSchnittRahmenQuerkraft() {
    }
	/**
     * Konstruktor mit allen ntigen Werten fr einen Grundrahmen
     * @param keller - Hhe des Kellers in [m]
     *        links  - Hhe des linken Stiels in [m]
     *        oben   - Breite des Riegels in [m]
     *        rechts - Hhe des rechten Stiels in [m]
     *        gelLinks - Gelenk oben links [boolean]
     *        gelRechts - Gelenk oben rechts [boolean]
     */
    public JPanelSchnittRahmenQuerkraft(  double keller ,
										   double links ,
										   double oben ,
										   double rechts ,
										   boolean gelLinks ,
										   boolean gelRechts ,
                                           double q11 ,
                                           double q22u ,
                                           double q22o ,
                                           double q238m ,
                                           double q33u ,
                                           double q33o ,
                                           double q44o ,
                                           double q44u ,
                                           double q458m ,
                                           double q55){
    	//Konstruktor des Superklasse aufrufen
		super(keller , links , oben , rechts , gelLinks , gelRechts);
		this.q11 = q11;
        this.q22u = q22u;
        this.q22o = q22o;
        this.q238m = q238m;
        this.q33u = q33u;
        this.q33o = q33o;
        this.q44o = q44o;
        this.q44u = q44u;
        this.q458m = q458m;
        this.q55 = q55;
    }


    /**
     * ber vererbungsinverse Ablikation knnen hier die Schnittkrfte
     * gezeichnet werden.
     * @param fixPktx - Fixpunkt unten links x - koordinate
     *        fixPkty - Fixpunkt unten links y - koordinate
     *        scale   - Scalierungsfaktor von [m] auf Pix
     *        g2      - Graphics Referenz
     */
    protected void setSchnittgroessen(float fixPktx ,
                                      float fixPkty ,
                                      float scale ,
                                      Graphics2D g2){

        //Dickenskalierung
        g2.setStroke(new BasicStroke(1));
        g2.setColor(Color.red);
      	g2.setFont(new Font("Serif" , Font.PLAIN, 16));
//Q Riegel
        //Schraffurrichtung
        float winkel =(float)(-Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel())-Math.PI/2);
        //Riegelrichtung
        float wri = (float)(Math.atan((getH_stielRechts()-getH_stielLinks())/getB_riegel()));
        //Lnge der Schraffur am linken Rand
		int ll = (int)(-q33o*scale*20);
        //Lnge der Schraffur am rechten Rand
		int lr = (int)(-q44o*scale*20);
		//Fupunkt links
		int xfl = (int)(fixPktx);
		int yfl = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks())-1*lin);
		//Fupunkt rechts
		int xfr = (int)(xfl+scale*getB_riegel());
		int yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts())-1*lin);
		//Endpunkt links
		int xel = (int)(xfl-Math.sin(wri)*ll);
		int yel = (int)(yfl-Math.cos(wri)*ll);
		//Endpunkt rechts
		int xer = (int)(xfr-Math.sin(wri)*lr);
		int yer = (int)(yfr-Math.cos(wri)*lr);
		//Teilungsfaktor
        float te = (float)(1.0/Math.round((xfr-xfl)/scale));
		int yf=0;
        int xf=0;
        float ls = 0;
		//Beschriftung
        int wortLaenge= 0;
        Color alt = g2.getColor();
        g2.setColor(Color.black);
        String q44oS = String.valueOf(q44o);
        q44oS = q44oS.substring(0, q44oS.length() > 6 ? 6 : q44oS.length());
        String q33oS = String.valueOf(q33o);
        q33oS = q33oS.substring(0, q33oS.length() > 6 ? 6 : q33oS.length());
        wortLaenge =((FontMetrics)g2.getFontMetrics()).stringWidth("Q = "+String.valueOf(q44oS)+"MN");
        g2.drawString("Q = "+String.valueOf(q44oS)+"MN",(int)(xfr-wortLaenge*0.5),yfr-10);
        g2.drawString("Q = "+String.valueOf(q33oS)+"MN",(int)(xfl-wortLaenge*0.5),yfl-10);
        g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
//Q Keller
        //Schraffurrichtung
        winkel =(float)Math.PI;
        //Lnge der Schraffur am linken Rand
		ll = (int)(-q11*scale*20);
        //Lnge der Schraffur am rechten Rand
		lr = (int)(-q22u*scale*20);
		//Fupunkt links
		xfl = (int)(fixPktx);
		yfl = (int)(fixPkty);
		//Fupunkt rechts
		xfr = xfl;
		yfr = (int)(fixPkty-scale*(getH_keller()));
		//Endpunkt links
		xel = (int)(xfl-ll);
		yel = (int)(yfl);
		//Endpunkt rechts
		xer = (int)(xfr-lr);
		yer = (int)(yfr);
		//Teilungsfaktor
        te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
		yf=0;
        xf=0;
        ls = 0;
		//Beschriftung
        alt = g2.getColor();
        g2.setColor(Color.black);
        String q11S = String.valueOf(q11);
        q11S = q11S.substring(0, q11S.length() > 6 ? 6 : q11S.length());
        String q22uS = String.valueOf(q22u);
        q22uS = q22uS.substring(0, q22uS.length() > 6 ? 6 : q22uS.length());
        g2.drawString("Q = "+String.valueOf(q11S)+"MN",xfl+10,yfl);
        g2.drawString("Q = "+String.valueOf(q22uS)+"MN",xfl+10,yfr+20);
        g2.setColor(alt);
		//Begrenzungslinien
		g2.drawLine(xfl,yfl,xfr,yfr);
		g2.drawLine(xel,yel,xer,yer);
		for(float i = 0 ; i <= 1 ; i+=te ){
			yf=(int)(yfl +(yfr-yfl)*i);
            xf=(int)(xfl + (xfr-xfl)*i);
			ls = (float)((lr-ll)*i+ll);
			setSchraffur(new Point(xf, yf), ls , winkel , g2);
		}
		setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
//Q links
        if(getH_stielLinks() <= 8){
			//Schraffurrichtung
			winkel =(float)Math.PI;
			//Lnge der Schraffur am linken Rand
			ll = (int)(-q22o*scale*20);
			//Lnge der Schraffur am rechten Rand
			lr = (int)(-q33u*scale*20);
			//Fupunkt links
			xfl = (int)(fixPktx);
			yfl = (int)(fixPkty-scale*getH_keller());
			//Fupunkt rechts
			xfr = xfl;
			yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks()));
			//Endpunkt links
			xel = (int)(xfl-ll);
			yel = (int)(yfl);
			//Endpunkt rechts
			xer = (int)(xfr-lr);
			yer = (int)(yfr);
			//Teilungsfaktor
			te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
			yf=0;
			xf=0;
			ls = 0;
			//Beschriftung
			alt = g2.getColor();
			g2.setColor(Color.black);
            String q22oS = String.valueOf(q22o);
            q22oS = q22oS.substring(0, q22oS.length() > 6 ? 6 : q22oS.length());
            String q33uS = String.valueOf(q33u);
            q33uS = q33uS.substring(0, q33uS.length() > 6 ? 6 : q33uS.length());
			g2.drawString("Q = "+String.valueOf(q22oS)+"MN",xfl+10,yfl-10);
			g2.drawString("Q = "+String.valueOf(q33uS)+"MN",xfl+10,yfr+20);
			g2.setColor(alt);
			//Begrenzungslinien
			g2.drawLine(xfl,yfl,xfr,yfr);
			g2.drawLine(xel,yel,xer,yer);
			for(float i = 0 ; i <= 1 ; i+=te ){
				yf=(int)(yfl +(yfr-yfl)*i);
				xf=(int)(xfl + (xfr-xfl)*i);
				ls = (float)((lr-ll)*i+ll);
				setSchraffur(new Point(xf, yf), ls , winkel , g2);
			}
			setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
        }else{
            //0 - 8m
			//Schraffurrichtung
			winkel =(float)Math.PI;
			//Lnge der Schraffur am linken Rand
			ll = (int)(-q22o*scale*20);
			//Lnge der Schraffur am rechten Rand
			lr = (int)(-q238m*scale*20);
			//Fupunkt links
			xfl = (int)(fixPktx);
			yfl = (int)(fixPkty-scale*getH_keller());
			//Fupunkt rechts
			xfr = xfl;
			yfr = (int)(fixPkty-scale*(getH_keller()+8));
			//Endpunkt links
			xel = (int)(xfl-ll);
			yel = (int)(yfl);
			//Endpunkt rechts
			xer = (int)(xfr-lr);
			yer = (int)(yfr);
			//Teilungsfaktor
			te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
			yf=0;
			xf=0;
			ls = 0;
			//Beschriftung
			alt = g2.getColor();
			g2.setColor(Color.black);
            String q22oS = String.valueOf(q22o);
            q22oS = q22oS.substring(0, q22oS.length() > 6 ? 6 : q22oS.length());
            String q238mS = String.valueOf(q238m);
            q238mS = q238mS.substring(0, q238mS.length() > 6 ? 6 : q238mS.length());
			g2.drawString("Q = "+String.valueOf(q22oS)+"MN",xfl+10,yfl-10);
			g2.drawString("Q = "+String.valueOf(q238mS)+"MN",xfl+10,yfr+20);
			g2.setColor(alt);
			//Begrenzungslinien
			g2.drawLine(xfl,yfl,xfr,yfr);
			g2.drawLine(xel,yel,xer,yer);
			for(float i = 0 ; i <= 1 ; i+=te ){
				yf=(int)(yfl +(yfr-yfl)*i);
				xf=(int)(xfl + (xfr-xfl)*i);
				ls = (float)((lr-ll)*i+ll);
				setSchraffur(new Point(xf, yf), ls , winkel , g2);
			}
			setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
            //8 - oben
			//Schraffurrichtung
			winkel =(float)Math.PI;
			//Lnge der Schraffur am linken Rand
			ll = (int)(-q238m*scale*20);
			//Lnge der Schraffur am rechten Rand
			lr = (int)(-q33u*scale*20);
			//Fupunkt links
			xfl = (int)(fixPktx);
			yfl = (int)(fixPkty-scale*(getH_keller()+8));
			//Fupunkt rechts
			xfr = xfl;
			yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielLinks()));
			//Endpunkt links
			xel = (int)(xfl-ll);
			yel = (int)(yfl);
			//Endpunkt rechts
			xer = (int)(xfr-lr);
			yer = (int)(yfr);
			//Teilungsfaktor
			te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
			yf=0;
			xf=0;
			ls = 0;
			//Beschriftung
			alt = g2.getColor();
			g2.setColor(Color.black);
            String q33uS = String.valueOf(q33u);
            q33uS = q33uS.substring(0, q33uS.length() > 6 ? 6 : q33uS.length());
			g2.drawString("Q = "+String.valueOf(q33uS)+"MN",xfl+10,yfr+20);
			g2.setColor(alt);
			//Begrenzungslinien
			g2.drawLine(xfl,yfl,xfr,yfr);
			g2.drawLine(xel,yel,xer,yer);
			for(float i = 0 ; i <= 1 ; i+=te ){
				yf=(int)(yfl +(yfr-yfl)*i);
				xf=(int)(xfl + (xfr-xfl)*i);
				ls = (float)((lr-ll)*i+ll);
				setSchraffur(new Point(xf, yf), ls , winkel , g2);
			}
			setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
        }
//Q rechts
		int wortl;
        int wortr;
        if(getH_stielRechts() <= 8){
			//Schraffurrichtung
			winkel =(float)Math.PI;
			//Lnge der Schraffur am linken Rand
			ll = (int)(q55*scale*20);
			//Lnge der Schraffur am rechten Rand
			lr = (int)(q44u*scale*20);
			//Fupunkt links
			xfl = (int)(fixPktx+scale*getB_riegel());
			yfl = (int)(fixPkty-scale*getH_keller());
			//Fupunkt rechts
			xfr = xfl;
			yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts()));
			//Endpunkt links
			xel = (int)(xfl-ll);
			yel = (int)(yfl);
			//Endpunkt rechts
			xer = (int)(xfr-lr);
			yer = (int)(yfr);
			//Teilungsfaktor
			te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
	    	yf=0;
			xf=0;
			ls = 0;
			//Beschriftung
			wortLaenge= 0;
			alt = g2.getColor();
			g2.setColor(Color.black);
            String q55S = String.valueOf(q55);
            q55S = q55S.substring(0, q55S.length() > 6 ? 6 : q55S.length());
            String q44uS = String.valueOf(q44u);
            q44uS = q44uS.substring(0, q44uS.length() > 6 ? 6 : q44uS.length());
			wortl =((FontMetrics)g2.getFontMetrics()).stringWidth("Q = "+String.valueOf(q55S)+"MN");
			g2.drawString("Q = "+String.valueOf(q55S)+"MN",xfr-wortl-10,yfl-10);
			wortr =((FontMetrics)g2.getFontMetrics()).stringWidth("Q = "+String.valueOf(q44uS)+"MN");
			g2.drawString("Q = "+String.valueOf(q44uS)+"MN",xfr-wortl-10,yfr+10);
			g2.setColor(alt);
			//Begrenzungslinien
			g2.drawLine(xfl,yfl,xfr,yfr);
			g2.drawLine(xel,yel,xer,yer);
			for(float i = 0 ; i <= 1 ; i+=te ){
				yf=(int)(yfl +(yfr-yfl)*i);
				xf=(int)(xfl + (xfr-xfl)*i);
				ls = (float)((lr-ll)*i+ll);
				setSchraffur(new Point(xf, yf), ls , winkel , g2);
			}
			setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
        }else{
            //0 - 8m
			//Schraffurrichtung
			winkel =(float)Math.PI;
			//Lnge der Schraffur am linken Rand
			ll = (int)(q55*scale*20);
			//Lnge der Schraffur am rechten Rand
			lr = (int)(q458m*scale*20);
			//Fupunkt links
			xfl = (int)(fixPktx+scale*getB_riegel());
			yfl = (int)(fixPkty-scale*getH_keller());
			//Fupunkt rechts
			xfr = xfl;
			yfr = (int)(fixPkty-scale*(getH_keller()+8));
			//Endpunkt links
			xel = (int)(xfl-ll);
			yel = (int)(yfl);
			//Endpunkt rechts
			xer = (int)(xfr-lr);
			yer = (int)(yfr);
			//Teilungsfaktor
			te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
	    	yf=0;
			xf=0;
			ls = 0;
			//Beschriftung
			wortLaenge= 0;
			alt = g2.getColor();
			g2.setColor(Color.black);
            String q55S = String.valueOf(q55);
            q55S = q55S.substring(0, q55S.length() > 6 ? 6 : q55S.length());
            String q458mS = String.valueOf(q458m);
            q458mS = q458mS.substring(0, q458mS.length() > 6 ? 6 : q458mS.length());
			wortl =((FontMetrics)g2.getFontMetrics()).stringWidth("Q = "+String.valueOf(q55S)+"MN");
			g2.drawString("Q = "+String.valueOf(q55S)+"MN",xfr-wortl-10,yfl-10);
			wortr =((FontMetrics)g2.getFontMetrics()).stringWidth("Q = "+String.valueOf(q458mS)+"MN");
			g2.drawString("Q = "+String.valueOf(q458mS)+"MN",xfr-wortl-10,yfr+10);
			g2.setColor(alt);
			//Begrenzungslinien
			g2.drawLine(xfl,yfl,xfr,yfr);
			g2.drawLine(xel,yel,xer,yer);
			for(float i = 0 ; i <= 1 ; i+=te ){
				yf=(int)(yfl +(yfr-yfl)*i);
				xf=(int)(xfl + (xfr-xfl)*i);
				ls = (float)((lr-ll)*i+ll);
				setSchraffur(new Point(xf, yf), ls , winkel , g2);
			}
			setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
        //8m - oben
			//Schraffurrichtung
			winkel =(float)Math.PI;
			//Lnge der Schraffur am linken Rand
			ll = (int)(q458m*scale*20);
			//Lnge der Schraffur am rechten Rand
			lr = (int)(q44u*scale*20);
			//Fupunkt links
			xfl = (int)(fixPktx+scale*getB_riegel());
			yfl = (int)(fixPkty-scale*(getH_keller()+8));
			//Fupunkt rechts
			xfr = xfl;
			yfr = (int)(fixPkty-scale*(getH_keller()+getH_stielRechts()));
			//Endpunkt links
			xel = (int)(xfl-ll);
			yel = (int)(yfl);
			//Endpunkt rechts
			xer = (int)(xfr-lr);
			yer = (int)(yfr);
			//Teilungsfaktor
			te = (float)Math.abs(1.0/Math.round((yfr-yfl)/scale));
	    	yf=0;
			xf=0;
			ls = 0;
			//Beschriftung
			wortLaenge= 0;
			alt = g2.getColor();
			g2.setColor(Color.black);
            String q44uS = String.valueOf(q44u);
            q44uS = q44uS.substring(0, q44uS.length() > 6 ? 6 : q44uS.length());
			wortr =((FontMetrics)g2.getFontMetrics()).stringWidth("Q = "+String.valueOf(q44uS)+"MN");
			g2.drawString("Q = "+String.valueOf(q44uS)+"MN",xfr-wortl-10,yfr+10);
			g2.setColor(alt);
			//Begrenzungslinien
			g2.drawLine(xfl,yfl,xfr,yfr);
			g2.drawLine(xel,yel,xer,yer);
			for(float i = 0 ; i <= 1 ; i+=te ){
				yf=(int)(yfl +(yfr-yfl)*i);
				xf=(int)(xfl + (xfr-xfl)*i);
				ls = (float)((lr-ll)*i+ll);
				setSchraffur(new Point(xf, yf), ls , winkel , g2);
			}
			setSchraffur(new Point(xfr, yfr), lr , winkel , g2);
        }
    }

    /**
     * Pfeile fr die Lasten
     * @param p - Fupunkt des Pfeils
     *        l - Lnge des Pfeils in Pix
     *        w - Winkel des Pfeils 0    -  3 Uhr
     *                              PI/2 - 12 Uhr
     * 								PI   -  9 Uhr...
     * 		 g2 - Zeichenobjekt
     */
    private void setSchraffur(Point p, float l, float w, Graphics2D g2){
		float sx = (float)p.getX();
        float sy = (float)p.getY();
        float zx = (float)(Math.cos(w)*l)+sx;
        float zy = (float)(Math.sin(w)*l)+sy;
        GeneralPath pfe = new GeneralPath();
        pfe.moveTo(sx, sy);
        pfe.lineTo(zx , zy);
		g2.draw(pfe);
    }


	private double q11 = 0;
	private double q22u = 0;
	private double q22o = 0;
	private double q238m = 0;
	private double q33u = 0;
	private double q33o = 0;
	private double q44o = 0;
	private double q44u = 0;
	private double q458m =0;
	private double q55 = 0;

    private float lin = 0;


}
