/* Generated by Together */

package gui;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.GeneralPath;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Stroke;


/**
 * Zeichnet die Normalkrfte im System 
 */
final class JPanelSchnittRahmenVerschiebung extends JPanelSchnittRahmen {
    public JPanelSchnittRahmenVerschiebung() {
    }
	/**
     * Konstruktor mit allen ntigen Werten fr einen Grundrahmen
     * @param keller - Hhe des Kellers in [m]
     *        links  - Hhe des linken Stiels in [m]
     *        oben   - Breite des Riegels in [m]
     *        rechts - Hhe des rechten Stiels in [m]
     *        gelLinks - Gelenk oben links [boolean]
     *        gelRechts - Gelenk oben rechts [boolean]
     */
    public JPanelSchnittRahmenVerschiebung( double keller ,
										   double links ,
										   double oben ,
										   double rechts ,
										   boolean gelLinks ,
										   boolean gelRechts ,
                                           double y1,
                                           double y2,
                                           double y3,
                                           double y4){
    	//Konstruktor des Superklasse aufrufen
		super(keller , links , oben , rechts , gelLinks , gelRechts);
        this.y1 = y1;
        this.y2 = y2;
        this.y3 = y3;
        this.y4 = y4;
    }


    /**
     * ber vererbungsinverse Ablikation knnen hier die Schnittkrfte
     * gezeichnet werden.
     * @param fixPktx - Fixpunkt unten links x - koordinate
     *        fixPkty - Fixpunkt unten links y - koordinate
     *        scale   - Scalierungsfaktor von [m] auf Pix
     *        g2      - Graphics Referenz
     */
    protected void setSchnittgroessen(float fixPktx ,
                                      float fixPkty ,
                                      float scale ,
                                      Graphics2D g2){

      	g2.setFont(new Font("Serif" , Font.PLAIN, 16));
        g2.drawString("Die roten Linien stellen die",10,20);
        g2.drawString("Sekanten der Verschiebungen dar.", 10,40);
		double grenz = Math.abs( Math.max(getH_stielLinks(),getH_stielRechts()) / 250);
        if(grenz>y2){
	        g2.drawString("Die Verschiebung in x - Richtung ist sehr gro",10,60);
    	    g2.drawString("Das System sollte steifer sein",10,80);
        }
        //Dickenskalierung
        g2.setStroke(new BasicStroke(1));
        g2.setColor(Color.red);
      	g2.setFont(new Font("Serif" , Font.PLAIN, 16));
        Stroke linalt = g2.getStroke();
        float[] dash = { 5 , 5 };
        g2.setStroke(new BasicStroke(1 , BasicStroke.CAP_BUTT ,
                     BasicStroke.JOIN_MITER , 1 , dash , 0));
		//Verstrkung
        double y1s = y1;
        double y2s = 1000*y2;
        double y3s = y3;
        double y4s = y4;
        //Verschiebungspunkte
        int p1x = (int)(fixPktx);
        int p1y = (int)(fixPkty);

        int p2x = (int)(p1x);
        int p2y = (int)(p1y-scale*getH_keller());

        int p3x = (int)(p2x+y2s);
        int p3y = (int)(p2y-scale*getH_stielLinks());

        int p4x = (int)(p3x+scale*getB_riegel());
        int p4y = (int)(p2y-scale*getH_stielRechts());

        int p5x = (int)(p2x+scale*getB_riegel());
        int p5y = (int)(p2y);

		g2.drawLine(p1x,p1y,p2x,p2y);
        g2.drawLine(p2x,p2y,p3x,p3y);
        g2.drawLine(p3x,p3y,p4x,p4y);
        g2.drawLine(p4x,p4y,p5x,p5y);

		//Beschriftung
        int wortLaenge= 0;
        Color alt = g2.getColor();
        g2.setColor(Color.black);
        String y2S = String.valueOf(y2);
        y2S = y2S.substring(0, y2S.length() > 6 ? 6 : y2S.length());
        wortLaenge =((FontMetrics)g2.getFontMetrics()).stringWidth("V(x) = "+String.valueOf(y2S)+"m");
        g2.drawString("V(x) = "+String.valueOf(y2S)+"m",(p3x+p4x-wortLaenge)/2,Math.min(p3y,p4y)-5);
        g2.setColor(alt);

    }
    private double y1 = 0;
    private double y2 = 0;
    private double y3 = 0;
    private double y4 = 0;

    private float lin = 0;


}
