package rahmen;
import java.util.*;
import bautabellen.IProfile;

/**
 * Das Eigengewicht und Einwirkungen aus den
 * Aufbauten werden hier beschrieben.
 * @author Johannes Hhne
 */
class Eigengewicht {

    /**
     * Gewichtskraft im linken Stiel  pro laufenden Meter in [MN/m]
     */
    private double g_Links = 0.0;
    void setG_Links(double g_Links){this.g_Links = g_Links;}


    /**
     * Gewichtskraft im rechten Stiel  pro laufenden Meter in [MN/m]
     */
    private double g_Rechts = 0.0;
    void setG_Rechts(double g_Rechts){this.g_Rechts = g_Rechts;}

    /**
     * Gewichtskraft im Riegel  pro laufenden Meter in [MN/m]
     */
    private double g_Riegel = 0.0;
    void setG_Riegel(double g_Riegel){this.g_Riegel = g_Riegel;}

    /**
     * Liefert die Gewichtskraft im linken Stiel in [MN] (Einzellast!)
     * @param abstand - Abstand der Rahmen untereinander in [m]
     * h - Hhe des Stiels in [m]
     * @return Gewichtskraft in [MN]
     */
    double getGlinks(double abstand, double h){
        return (1.35*(g_Links));
    }

    /**
     * Liefert die Gewichtskraft im rechten Stiel in [MN] (Einzellast!)
     * @param abstand - Abstand der Rahmen untereinander in [m]
     * h - Hhe des Stiels in [m]
     * @return Gewichtskraft in [MN]
     */
    double getGrechts(double abstand, double h){
        return (1.35*(g_Rechts));
    }

    /**
     * Liefert die Gewichtskraft im Dach in [MN/m]
     * @param abstand - Abstand der Rahmen untereinander in [m]
     * alpha  - Neigung des Daches in [rad]
     * @return Gewichtskraft in [MN/m]
     */
    double getDach(double abstand, double alpha){
        return (1.35*(g_Riegel)/Math.cos(Math.abs(alpha)));
    }



}
