package rahmen;
import java.util.*;

/**
 * der Erddruck als stndige Last und aus Personenauflast
 * wird hier beschrieben
 * @author Johannes Hhne
 */
class Erddruck {

    /**
     * Reibungswinkel phi in []
     */
    private int phi = 0;
    double winkel = 0.0;
    void setPhi(int phi){
        this.phi = phi;
		this.winkel = Math.tan(Math.toRadians(45-phi/2))*Math.tan(Math.toRadians(45-phi/2));
    }
    int getPhi(){return phi;}

    /**
     * Bodenlast in [MN/m^3]
     */
    private double gamma = 0.0;
    void setGamma(double gamma){this.gamma = gamma;}
    double getGamma(){return gamma;}

    /**
     * Personenauflast in [N/mm^2]
     */
    private double p = 0.0;
    void setP(double p){this.p = p;}
    double getP(){return p;}

    /**
     * Liefert das Eigengewicht aus dem Erddruck in [MN/m]
     * @param h - Hhe des Bauteils in [m]
     * @return Eigengewicht aus Erddruck in [MN/m]
     */
    double getGErd(double h){
        return (1.35*gamma*h*h*winkel);
    }

    /**
     * Liefert den Erddruck aus Personenauflast in [MN/m]
     * @param h - Hhe des Bauteils in [m]
     * @return Erddruck aus Personenlast  in [MN/m]
     */
    double getPErd(double h){
        return (1.5*p*h*winkel);
    }

}
