package rahmen;
import java.util.*;

/**
 * Hier wird die Situation Wind von links sowie von Rechts beschrieben.
 * Dabei mu die Hhe des Bauteils beachtet werden und dessen Neigung.
 */
public class Wind {
  /* {author=Johannes Hhne}*/

    /**
     * Liefert den Winddruck auf ein senkrechtes Gebudeteil
     * mit eine Hhe von 0 bis 8m ber Gelndeoberkante in[MN/m]
     * @param a = Abstand Der Rahmen zueinander in [m]
     * @return Winddruck in [MN/m]
     */
    public double getDruck0_8(double abstand) {
        return (1.5*abstand*0.0005*0.8);
    }
    /**
     * Liefert den Winddruck auf ein senkrechtes Gebudeteil
     * mit eine Hhe von 8 bis 20m ber Gelndeoberkante in[MN/m]
     * @param a = Abstand Der Rahmen zueinander in [m]
     * @return Winddruck in [MN/m]
     */
    public double getDruck8_20(double abstand) {
        return (1.5*abstand*0.0008*0.8);
    }

    /**
     * Liefert den Windsog auf ein senkrechtes dem Wind abgewantes
     * Gebudeteil mit eine Hhe von 0 bis 8m ber Gelndeoberkante in[MN/m]
     * @param a = Abstand Der Rahmen zueinander in [m]
     * @return Winddruck in [MN/m]
     */
    public double getSog0_8(double abstand) {
        return (1.5*abstand*0.0005*0.5);
    }

    /**
     * Liefert den Windsog auf ein senkrechtes dem Wind abgewantes
     * Gebudeteil mit eine Hhe von 8 bis 20m ber Gelndeoberkante in[MN/m]
     * @param a = Abstand Der Rahmen zueinander in [m]
     * @return Winddruck in [MN/m]
     */
    public double getSog8_20(double abstand) {
        return (1.5*abstand*0.0008*0.5);
    }

    /**
     * Liefert den Windsog auf ein hchstens um 25 geneigte Flche
     * Gebudeteil mit eine Hhe von 0 bis 8m ber Gelndeoberkante in[MN/m]
     * @param a = Abstand Der Rahmen zueinander in [m]
     * @return Winddruck in [MN/m]
     */
    public double getSogDach0_8(double abstand) {
        return (1.5*abstand*0.0005*0.5*0.6);
    }

    /**
     * Liefert den Windsog auf ein hchstens um 25 geneigte Flche
     * Gebudeteil mit eine Hhe von 8 bis 20m ber Gelndeoberkante in[MN/m]
     * @param a = Abstand Der Rahmen zueinander in [m]
     * @return Winddruck in [MN/m]
     */
    public double getSogDach8_20(double abstand) {
        return (1.5*abstand*0.0008*0.5*0.6);
    }
}
